/** @file CircleProgress.h
* @brief ͽؼԲмı85%
* @copyright (c) 2019-2022, NetEase Inc. All rights reserved
* @author Xuhuajie
* @date 2019/8/14
*/

#ifndef UI_CONTROL_CIRCLEPROGRESS_H_
#define UI_CONTROL_CIRCLEPROGRESS_H_

#pragma once

namespace ui
{

class UILIB_API CircleProgress : public Progress
{
public:
	CircleProgress();

	/// д෽ṩԻܣο
	virtual void SetAttribute(const std::wstring& strName, const std::wstring& strValue) override;
	virtual void PaintStatusImage(IRenderContext* pRender) override;
	virtual void ClearImageCache() override;

	/**
	* @brief ûͽĬΪͨ
	* @param[in] bCircular Ϊ true ʱΪͽfalse ʱΪʽĬΪ true
	* @return 
	*/
	void SetCircular(bool bCircular = true);

	/**
	* @brief õ
	* @param[in] bClockwise Ϊ true ʱΪ˳ʱ룬false ʱΪʱ룬ĬΪ true
	* @return 
	*/
	void SetClockwiseRotation(bool bClockwise = true);

	/**
	* @brief Բ
	* @param[in] nCircleWidth ֵ
	* @return 
	*/
	void SetCircleWidth(int nCircleWidth);

	/**
	* @brief ýɫ
	* @param[in] strColorҪõıɫַַ global.xml д
	* @return 
	*/
	void SetBackgroudColor(const std::wstring& strColor);

	/**
	* @brief ýǰɫ
	* @param[in] strColorҪõǰɫַַ global.xml д
	* @return 
	*/
	void SetForegroudColor(const std::wstring& strColor);

	/**
	* @brief ýǰɫ SetForegroudColor ͬʱʹãԲ,޽Ч
	* @param[in] strColorҪõǰɫַַ global.xml д
	* @return 
	*/
	void SetCircleGradientColor(const std::wstring& strColor);

	/**
	* @brief ýָʾƶͼ
	* @param[in] sIndicatorImage ҪõͼƬ
	* @return 
	*/
	void SetIndicator(const std::wstring& sIndicatorImage);

protected:
	bool			m_bCircular;
	bool			m_bClockwise;
	int				m_nCircleWidth;
	DWORD			m_dwBackgroundColor;
	DWORD			m_dwForegroundColor;
	DWORD			m_dwGradientColor;
	Gdiplus::Image*	m_pIndicator;   //ĿǰάԴ
	std::wstring	m_sIndicatorImage;

};

} // namespace ui

#endif // UI_CONTROL_CIRCLEPROGRESS_H_
