#ifndef UI_CONTROL_COMBO_H_
#define UI_CONTROL_COMBO_H_

#pragma once

namespace ui 
{

class CComboWnd;
class UILIB_API Combo : public Box
{
    friend class CComboWnd;
public:
	Combo();
	Combo(const Combo& r) = delete;
	Combo& operator=(const Combo& r) = delete;

	/// д෽ṩԻܣο
	virtual bool Add(Control* pControl) override;
	virtual bool Remove(Control* pControl) override;
	virtual bool RemoveAt(std::size_t iIndex) override;
	virtual void RemoveAll() override;
	virtual void Activate() override;
	virtual void SetAttribute(const std::wstring& strName, const std::wstring& strValue) override;
	virtual void PaintText(IRenderContext* pRender) override;

	/**
	 * @brief ȡǰѡı
	 * @return صǰѡı
	 */
    std::wstring GetText() const;

	/**
	 * @brief ȡǰ List 
	 * @return  List ָ
	 */
	ListBox* GetListBox() { return m_pLayout.get(); }

	/**
	 * @brief ȡϢ
	 * @return ַʽϢ
	 */
    std::wstring GetDropBoxAttributeList();

	/**
	 * @brief Ϣ
	 * @param[in] pstrList ת XML ʽб
	 * @return 
	 */
    void SetDropBoxAttributeList(const std::wstring& pstrList);

	/**
	 * @brief ȡС
	 * @return С
	 */
    CSize GetDropBoxSize() const;

	/**
	 * @brief С
	 * @param[in] szDropBox ҪõĴСϢ
	 * @return 
	 */
    void SetDropBoxSize(CSize szDropBox);
	
	/**
	 * @brief  Combobox Ƿϵ
	 * @param[in] top Ϊ true ϵfalse ΪĬµ
	 * @return 
	 */
	void SetPopupTop(bool top) { m_bPopupTop = top; };
	
	/**
	 * @brief ж Combobox ģʽǷϵ
	 * @return  true ʾϵΪ false
	 */
	bool IsPopupTop() const { return m_bPopupTop; };

	/**
	 * @brief ѡһ
	 * @param[in] iIndex Ҫѡ
	 * @return  true ʾɹΪ false
	 */
	bool SelectItem(int iIndex);

	/**
	 * @brief ȡָµؼ
	 * @param[in] iIndex Ҫȡ
	 * @return ؿؼָ
	 */
	Control* GetItemAt(int iIndex);

	/**
	 * @brief ȡǰѡ
	 * @return صǰѡ
	 */
	int GetCurSel() const { return m_iCurSel; }

	/**
	 * @brief ȡ
	 * @return 
	 */
	virtual int GetCount() const { return m_pLayout->GetCount(); }
    
	/**
	 * @brief ѡ¼
	 * @param[in] callback ѡ󴥷Ļص
	 * @return 
	 */
	void AttachSelect(const EventCallback& callback) { m_pLayout->AttachSelect(callback); }

private:
	/**
	 * @brief Ĭϵѡ
	 * @param[in] args б
	 * @return ʼշ true
	 */
	bool OnSelectItem(EventArgs* args);

protected:
    CComboWnd *m_pWindow;
	std::unique_ptr<ListBox> m_pLayout;
    int m_iCurSel;  
	ControlStateType m_uButtonState;
	CSize m_szDropBox;
	std::wstring m_sDropBoxAttributes;
	bool m_bPopupTop;
};

} // namespace ui

#endif // UI_CONTROL_COMBO_H_
