#ifndef UI_CONTROL_RICHEDIT_H_
#define UI_CONTROL_RICHEDIT_H_

#pragma once

#include <Imm.h>
#include <textserv.h>
#include <richedit.h>
#include <RichOle.h>

namespace ui 
{

class CTxtWinHost;
class UILIB_API RichEdit : public ScrollableBox
{
public:
	friend class CTxtWinHost;
	typedef std::function<bool(LONG, LONG, CSize&)> FunGetNaturalSize;
public:
	RichEdit();
	RichEdit(const RichEdit& r) = delete;
	RichEdit& operator=(const RichEdit& r) = delete;
    ~RichEdit();

	/**
	 * @brief жǷ TAB Ϣ
	 * @return  true ʾܣfalse ʾ
	 */
    bool IsWantTab();

	/**
	 * @brief жǷ TAB Ϣ
	 * @param[in] bWantTab Ϊ true ܸϢfalse Ϊ
	 * @return 
	 */
    void SetWantTab(bool bWantTab = true);

	/**
	 * @brief жǷ RETURN Ϣ
	 * @return  true ʾܣfalse ʾ
	 */
    bool IsNeedReturnMsg();

	/**
	 * @brief Ƿ RETURN Ϣ
	 * @param[in] bNeedReturnMsg Ϊ true ܸϢfalse Ϊ
	 * @return 
	 */
    void SetNeedReturnMsg(bool bNeedReturnMsg = true);

	/**
	 * @brief жǷCTRL+RETURN ϼϢ
	 * @return  true ʾܣfalse ʾ
	 */
    bool IsReturnMsgWantCtrl();

	/**
	 * @brief ǷCTRL+RETUREN ϼϢ
	 * @param[in] bReturnMsgWantCtrl Ϊ true ܸϢfalse Ϊ
	 * @return 
	 */
    void SetReturnMsgWantCtrl(bool bReturnMsgWantCtrl = true);

	/**
	 * @brief ǷǸı״̬
	 * @return  true ΪǣΪ false
	 */
    bool IsRich();

	/**
	 * @brief ÿؼΪı༭״̬
	 * @param[in] bRich  true Ϊı״̬false Ϊͨ״̬
	 * @return 
	 */
    void SetRich(bool bRich = true);

	/**
	 * @brief Ƿֻ״̬
	 * @return  true Ϊֻ״̬Ϊ false
	 */
    bool IsReadOnly();

	/**
	 * @brief ÿؼΪֻ״̬
	 * @param[in] bReadOnly  true ÿؼΪֻ״̬false Ϊд״̬
	 * @return 
	 */
    void SetReadOnly(bool bReadOnly = true);

	/**
	 * @brief Ƿ״̬ؼ
	 * @return  true ʾؼΪ false
	 */
	bool IsPassword();

	/**
	 * @brief ÿؼΪؼʾ ***
	 * @param[in] bPassword Ϊ true ÿؼʾΪ ***false Ϊʾ
	 * @return 
	 */
	void SetPassword(bool bPassword);

	/**
	 * @brief ȡıʾʽ
	 * @return  true ʱڶģʽݱʾfalse ʾضʾ
	 */
    bool GetWordWrap();

	/**
	 * @brief óıʾʽ
	 * @param[in] bWordWrap Ϊ true ʱڶģʽݱʾfalse ʾضʾ
	 * @return 
	 */
    void SetWordWrap(bool bWordWrap = true);

	/**
	 * @brief ȡǰõ
	 * @return Ӧ global.xml ˳
	 */
	std::wstring GetFont() const;

	/**
	 * @brief 
	 * @param[in] index ҪõӦ global.xml ˳
	 * @return 
	 */
	void SetFont(const std::wstring& strFontId);
	void SetFont(HFONT font);
	/**
	 * @brief 
	 * @param[in] pStrFontName 
	 * @param[in] nSize С
	 * @param[in] bBold Ƿʾ
	 * @param[in] bUnderline Ƿ»
	 * @param[in] bItalic Ƿбʾ
	 * @return 
	 */
    void SetFont(const std::wstring& pStrFontName, int nSize, bool bBold, bool bUnderline, bool bItalic);

	/**
	 * @brief ȡʽ
	 * @return شʽ
	 */
    LONG GetWinStyle();

	/**
	 * @brief ôʽ
	 * @param[in] lStyle ҪõĴʽ
	 * @return 
	 */
    void SetWinStyle(LONG lStyle);

	/**
	 * @brief ȡݴֱ䷽ʽ
	 * @return ݴֱ䷽ʽ˶롢С׶˶룩
	 */
	VerAlignType GetTextVerAlignType();

	/**
	 * @brief ıɫ
	 * @param[in] dwTextColor Ҫõıɫɫ global.xml д
	 * @return 
	 */
	virtual void SetTextColor(const std::wstring& dwTextColor);
	void SetTextColor(DWORD color);

	/**
	 * @brief ȡıɫ
	 * @return صǰıɫ
	 */
	std::wstring GetTextColor();

	/**
	 * @brief ȡַ
	 * @return ַ
	 */
    int GetLimitText();

	/**
	 * @brief ַ
	 * @param[in] iChars ҪƵַ
	 * @return 
	 */
    void SetLimitText(int iChars);

	/**
	 * @brief ȡݵĳ
	 * @param[in] dwFlags ָȷıȵķʽο https://docs.microsoft.com/en-us/windows/desktop/controls/em-gettextlengthex
	 * @return ݳ
	 */
    long GetTextLength(DWORD dwFlags = GTL_DEFAULT) const;

	/**
	 * @brief ȡؼеı
	 * @return ؿؼеı
	 */
    std::wstring GetText() const;

	/**
	 * @brief ȡؼеı
	 * @return ؿؼеı UTF8 ʽ
	 */
	virtual std::string GetUTF8Text() const;

	/**
	 * @brief ÿؼı
	 * @param[in] strText Ҫõı
	 * @return 
	 */
    void SetText(const std::wstring& strText);

	/**
	 * @brief ÿؼıӦ ID
	 * @param[in] strTextId Ҫõ ID ID ڼصļд
	 * @return 
	 */
	void SetTextId(const std::wstring& strTextId);

	/**
	 * @brief ÿؼıӦ ID
	 * @param[in] strTextId Ҫõ UTF8 ʽ ID ID ڼصļд
	 * @return 
	 */
	virtual void SetUTF8Text(const std::string& strText);

	/**
	 * @brief ȡ޸ı־
	 * @return  true Ϊ޸ı־Ϊ false
	 */
    bool GetModify() const;

	/**
	 * @brief ޸ı־
	 * @param[in] bModified Ϊ true ʾıѾ޸ģfalse Ϊδ޸ģĬΪ true
	 * @return 
	 */
    void SetModify(bool bModified = true) const;

	/**
	 * @brief ȡѡıʼλúͽλ
	 * @param[out] cr ʼλúͽλ
	 * @return 
	 */
    void GetSel(CHARRANGE &cr) const;

	/**
	 * @brief ȡѡıʼλúͽλ
	 * @param[in] nStartChar ʼλ
	 * @param[in] nEndChar ؽλ
	 * @return 
	 */
    void GetSel(long& nStartChar, long& nEndChar) const;

	/**
	 * @brief ѡһ
	 * @param[in] cr Ҫѡʼλúͽλ
	 * @return ѡ
	 */
    int SetSel(CHARRANGE &cr);

	/**
	 * @brief ѡһ
	 * @param[in] nStartChar Ҫѡʼλ
	 * @param[in] nEndChar ҪѡĽλ
	 * @return ѡ
	 */
    int SetSel(long nStartChar, long nEndChar);

	/**
	 * @brief 滻ѡ
	 * @param[in] lpszNewText Ҫ滻
	 * @param[in] bCanUndo ǷԳtrue ΪԣΪ false
	 * @return 
	 */
    void ReplaceSel(const std::wstring& lpszNewText, bool bCanUndo);

	/**
	 * @brief 滻ѡ
	 * @param[in] lpszNewText Ҫ滻
	 * @param[in] bCanUndo ǷԳtrue ΪԣΪ false
	 * @return 
	 */
    void ReplaceSelW(LPCWSTR lpszNewText, bool bCanUndo = false);

	/**
	 * @brief ȡѡ
	 * @return ѡ
	 */
    std::wstring GetSelText() const;

	/**
	 * @brief ȫѡ
	 * @return ѡ
	 */
    int SetSelAll();

	/**
	 * @brief ѡκ
	 * @return ʼշ 0 
	 */
    int SetSelNone();

	/**
	 * @brief ȡؼѡ
	 * @return ؿؼѡͣοhttps://docs.microsoft.com/en-us/windows/desktop/controls/em-selectiontype
	 */
    WORD GetSelectionType() const;

	/**
	 * @brief ȡǰű
	 * @param[out] nNum űʷ
	 * @param[out] nDen űʷĸ
	 * @return Ϣ򷵻 TRUE
	 */
    bool GetZoom(int& nNum, int& nDen) const;

	/**
	 * @brief ű
	 * @param[in] nNum űʷ
	 * @param[in] nDen űʷĸ
	 * @return ɹ trueʧܷ false
	 */
    bool SetZoom(int nNum, int nDen);

	/**
	 * @brief ָŵʼ״̬
	 * @return ɹ true򷵻 false
	 */
    bool SetZoomOff();

	/**
	 * @brief ȡǷԶ URL 
	 * @return  true ʾԶ⣬Ϊ false
	 */
    bool GetAutoURLDetect() const;

	/**
	 * @brief Ƿ URL Զ
	 * @param[in] bAutoDetect Ϊ true ʾ URLfalse Ϊ⣬ĬΪ true
	 * @return  true Ϊóɹfalse Ϊʧ
	 */
    bool SetAutoURLDetect(bool bAutoDetect = true);

	/**
	 * @brief ȡؼ¼
	 * @return ¼
	 */
    DWORD GetEventMask() const;

	/**
	 * @brief ÿؼ¼
	 * @param[in] dwEventMask Ҫõ¼ֵ
	 * @return ֮ǰ¼ֵ
	 */
    DWORD SetEventMask(DWORD dwEventMask);

	/**
	 * @brief ȡָΧ
	 * @param[in] nStartChar ʼλ
	 * @param[in] nEndChar Ϊֹ
	 * @return õָλõ
	 */
    std::wstring GetTextRange(long nStartChar, long nEndChar) const;

	/**
	 * @brief Ƿػʾѡֵ
	 * @param[in] bHide Ƿʾtrue Ϊʾfalse Ϊʾ
	 * @param[in] bChangeStyle Ƿ޸ʽtrue Ϊ޸ģfalse Ϊ޸
	 * @return 
	 */
    void HideSelection(bool bHide = true, bool bChangeStyle = false);

	/**
	 * @brief ù굽ɼλ
	 * @return 
	 */
    void ScrollCaret();

	/**
	 * @brief 
	 * @param[in] nInsertAfterChar Ҫλ
	 * @param[in] lpstrText Ҫı
	 * @param[in] bCanUndo ǷԳtrue ΪԣΪ falseĬΪ false
	 * @return زıλ
	 */
    int InsertText(long nInsertAfterChar, LPCTSTR lpstrText, bool bCanUndo = false);

	/**
	 * @brief ׷
	 * @param[in] strText Ҫ׷ӵ
	 * @param[in] bCanUndo ǷԳtrue ΪԣΪ falseĬΪ false
	 * @return ׷Ӻλ
	 */
    int AppendText(const std::wstring& strText, bool bCanUndo = false);

	/**
	 * @brief ȡַʽ
	 * @param[out] cf ػȡַʽ
	 * @return ز cf  dwMask ֵ
	 */
    DWORD GetDefaultCharFormat(CHARFORMAT2 &cf) const;

	/**
	 * @brief Ĭϵַʽ
	 * @param[in] cf Ҫַʽ
	 * @return  true ʾɹfalse Ϊʧ
	 */
    bool SetDefaultCharFormat(CHARFORMAT2 &cf);

	/**
	 * @brief ȡѡַʽ
	 * @param[out] cf ػȡַʽ
	 * @return ز cf  dwMask ֵ
	 */
    DWORD GetSelectionCharFormat(CHARFORMAT2 &cf) const;

	/**
	 * @brief ñѡַʽ
	 * @param[in] cf Ҫõַʽ
	 * @return  true ʾɹfalse Ϊʧ
	 */
    bool SetSelectionCharFormat(CHARFORMAT2 &cf);

	/**
	 * @brief õǰĵʸʽ
	 * @param[in] cf Ҫõĵʸʽ
	 * @return ɹ trueʧܷ false
	 */
    bool SetWordCharFormat(CHARFORMAT2 &cf);

	/**
	 * @brief ȡǰʽ
	 * @param[out] pf صǰʽ
	 * @return  pf  dwMask Ա
	 */
    DWORD GetParaFormat(PARAFORMAT2 &pf) const;

	/**
	 * @brief õǰʽ
	 * @param[in] pf ҪõĶʽʽ
	 * @return ɹ true򷵻 false
	 */
    bool SetParaFormat(PARAFORMAT2 &pf);

	/**
	 * @brief ָ
	 * @return ɹ trueʧܷ false
	 */
    bool Redo();

	/**
	 * @brief 
	 * @return ɹ trueʧܷ false
	 */
    bool Undo();

	/**
	 * @brief 
	 * @return 
	 */
    void Clear();

	/**
	 * @brief ѡ
	 * @return 
	 */
    void Copy();

	/**
	 * @brief ѡ
	 * @return 
	 */
    void Cut();

	/**
	 * @brief ճ
	 * @return 
	 */
	void Paste();

	/**
	 * @brief Ƿճָаʽ
	 * @param[in] nFormat Ҫĸʽ
	 * @return Է true򷵻 false
	 */
	BOOL CanPaste(UINT nFormat = 0);

	/**
	 * @brief ڿؼճضļʽ
	 * @param[in] uClipFormat ָаʽ
	 * @param[in] dwAspect ָչʾʽ
	 * @param[in] hMF  dwAspect Ϊ DVASPECT_ICONúӦðͼ
	 * @return 
	 */
	void PasteSpecial(UINT uClipFormat, DWORD dwAspect = 0, HMETAFILE hMF = 0);

	/**
	 * @brief ȡ
	 * @return 
	 */
    int GetLineCount() const;

	/**
	 * @brief ȡһ
	 * @param[in] nIndex Ҫȡ
	 * @param[in] nMaxLength Ҫȡǰݳ
	 * @return ػȡһ
	 */
    std::wstring GetLine(int nIndex, int nMaxLength) const;

	/**
	 * @brief ȡָеĵһַ
	 * @param[in] nLine ҪȡڼݣĬΪ -1
	 * @return ָеĵһַ
	 */
    int LineIndex(int nLine = -1) const;

	/**
	 * @brief ȡָеݳ
	 * @param[in] nLine ҪȡڼݣĬΪ -1
	 * @return ָеݳ
	 */
    int LineLength(int nLine = -1) const;

	/**
	 * @brief ı
	 * @param[in] nLines ֱָ
	 * @param[in] nChars ָˮƽ
	 * @return ɹ trueʧܷ false
	 */
    bool LineScroll(int nLines, int nChars = 0);

	/**
	 * @brief ȡָλַĿͻ
	 * @param[in] lChar ַλ
	 * @return ؿͻ
	 */
	CPoint GetCharPos(long lChar) const;

	/**
	 * @brief ȡַָ
	 * @param[in] nIndex ַλ
	 * @return صǰַڵ
	 */
    long LineFromChar(long nIndex) const;

	/**
	 * @brief ȡָλַĿͻ
	 * @param[in] nChar ַλ
	 * @return ؿͻ
	 */
    CPoint PosFromChar(UINT nChar) const;

	/**
	 * @brief 귵ַָ
	 * @param[in] pt Ϣ
	 * @return ӽ pt ָλ
	 */
	int CharFromPos(CPoint pt) const;

	/**
	 * @brief ճб
	 * @return 
	 */
    void EmptyUndoBuffer();

	/**
	 * @brief óбɵ
	 * @param[in] nLimit
	 * @return úĳб
	 */
    UINT SetUndoLimit(UINT nLimit);

	/**
	 * @brief һصڿ
	 * @param[in] nFormat ָݸʽ滻ѡhttps://docs.microsoft.com/en-us/windows/desktop/controls/em-streamin
	 * @param[in] es ԶصĽṹ
	 * @return ضݴС
	 */
    long StreamIn(int nFormat, EDITSTREAM &es);

	/**
	 * @brief ָһصڿ
	 * @param[in] nFormat ָݸʽ滻ѡhttps://docs.microsoft.com/en-us/windows/desktop/controls/em-streamin
	 * @param[in] es ԶصĽṹ
	 * @return дݴС
	 */
    long StreamOut(int nFormat, EDITSTREAM &es);

    // ע⣺TxSendMessageSendMessageģTxSendMessageûmultibyteunicodeԶתĹܣ
    // richedit2.0ڲunicodeʵֵģmultibyteУԼunicodemultibyteת	
    virtual HRESULT TxSendMessage(UINT msg, WPARAM wparam, LPARAM lparam, LRESULT *plresult) const; 
	IDropTarget* GetTxDropTarget();
	bool SetDropAcceptFile(bool bAccept);
	virtual void OnTxNotify(DWORD iNotify, void *pv);
    virtual bool OnTxTextChanged();
	ITextHost* GetTextHost();
	ITextServices* GetTextServices();
	BOOL SetOleCallback(IRichEditOleCallback* pCallback);
	CSize GetNaturalSize(LONG width, LONG height);
	void SetImmStatus(BOOL bOpen);
	void SetTimer(UINT idTimer, UINT uTimeout);
	void KillTimer(UINT idTimer);

	/**
	 * @brief ùλ
	 * @param[in] szPos ҪõĹλϢ
	 * @return 
	 */
    void SetScrollPos(CSize szPos);

	/**
	 * @brief һ
	 * @return 
	 */
    void LineUp();

	/**
	 * @brief һ
	 * @return 
	 */
    void LineDown();

	/**
	 * @brief Ϸҳ
	 * @return 
	 */
    void PageUp();

	/**
	 * @brief ·ҳ
	 * @return 
	 */
    void PageDown();

	/**
	 * @brief ص
	 * @return 
	 */
    void HomeUp();

	/**
	 * @brief صײ
	 * @return 
	 */
    void EndDown();

	/**
	 * @brief ˮƽ
	 * @return 
	 */
    void LineLeft();

	/**
	 * @brief ˮƽҹ
	 * @return 
	 */
    void LineRight();

	/**
	 * @brief ˮƽҳ
	 * @return 
	 */
    void PageLeft();

	/**
	 * @brief ˮƽҷҳ
	 * @return 
	 */
    void PageRight();

	/**
	 * @brief ص
	 * @return 
	 */
    void HomeLeft();

	/**
	 * @brief ص
	 * @return 
	 */
    void EndRight();

	virtual void DoInit() override;
	virtual void SetEnabled(bool bEnable = true) override;
	virtual CSize EstimateSize(CSize szAvailable) override;
	virtual void SetPos(UiRect rc) override;
	virtual UINT GetControlFlags() const override;
	virtual void HandleMessage(EventArgs& event) override;
	void OnSetCursor(EventArgs& event);
	void OnSetFocus(EventArgs& event);
	void OnKillFocus(EventArgs& event);
	void OnChar(EventArgs& event);
	void OnKeyDown(EventArgs& event);
	void OnImeStartComposition(EventArgs& event);
	void OnImeEndComposition(EventArgs& event);
	void OnMouseMessage(UINT uMsg, EventArgs& event);

	virtual void Paint(IRenderContext* pRender, const UiRect& rcPaint) override;
	virtual void PaintChild(IRenderContext* pRender, const UiRect& rcPaint) override;
	virtual void SetAttribute(const std::wstring& pstrName, const std::wstring& pstrValue) override;

	/**
	 * @brief 
	 * @param[in] xWidth 
	 * @param[in] yHeight ߶
	 * @return ɹ trueʧܷ false
	 */
	BOOL CreateCaret(INT xWidth, INT yHeight);

	/**
	 * @brief Ƿʾ
	 * @param[in] fShow  true Ϊʾfalse Ϊʾ
	 * @return ɹ trueʧܷ false
	 */
	BOOL ShowCaret(BOOL fShow);

	/**
	 * @brief ùɫ
	 * @param[in] dwColor Ҫõɫֵֵ global.xml д
	 * @return 
	 */
	void SetCaretColor(const std::wstring& dwColor);

	/**
	 * @brief ȡɫ
	 * @return عɫ
	 */
	std::wstring GetCaretColor();

	/**
	 * @brief ȡλ
	 * @return عλ
	 */
	RECT GetCaretRect();

	/**
	 * @brief ùλ
	 * @param[in] x X 
	 * @param[in] y Y 
	 * @return ɹ trueʧܷ false
	 */
	BOOL SetCaretPos(INT x, INT y);

	/**
	 * @brief лǷʾ
	 * @return 
	 */
	void ChangeCaretVisiable();

	/**
	 * @brief ƹ
	 * @param[in] pRender 
	 * @param[in] rcPaint λ
	 * @return 
	 */
	void PaintCaret(IRenderContext* pRender, const UiRect& rcPaint);

	/**
	 * @brief Ƿʾʾ
	 * @param[in] bPrompt Ϊ true Ϊʾfalse Ϊʾ
	 * @return 
	 */
	void SetPromptMode(bool bPrompt);

	/**
	 * @brief ȡʾ
	 * @return ʾ
	 */
	std::wstring GetPromptText() const;

	/**
	 * @brief ȡʾ
	 * @return  UTF8 ʽʾ
	 */
	std::string GetUTF8PromptText() const;

	/**
	 * @brief ʾ
	 * @param[in] strText Ҫõʾ
	 * @return 
	 */
	void SetPromptText(const std::wstring& strText);

	/**
	 * @brief ʾ
	 * @param[in] strText Ҫõ UTF8 ʽʾ
	 * @return 
	 */
	void SetUTF8PromptText(const std::string& strText);

	/**
	 * @brief ʾ ID
	 * @param[in] strText Ҫõʾ ID ID ڼصļд
	 * @return 
	 */
	void SetPromptTextId(const std::wstring& strTextId);

	/**
	 * @brief ʾ ID
	 * @param[in] strText Ҫõ UTF8 ʽʾ ID ID ڼصļд
	 * @return 
	 */
	void SetUTF8PromptTextId(const std::string& strTextId);

	/**
	 * @brief ʾ
	 * @param[in] pRender 
	 * @return 
	 */
	void PaintPromptText(IRenderContext* pRender);

	/**
	 * @brief ȡ״̬µͼƬ
	 * @return ؽ״̬µͼƬ
	 */
	std::wstring GetFocusedImage();

	/**
	 * @brief ý״̬µͼƬ
	 * @param[in] strImage ҪõͼƬλ
	 * @return 
	 */
	void SetFocusedImage(const std::wstring& strImage);

	/**
	 * @brief ָ״̬µͼƬ
	 * @param[in] pRender 
	 * @return 
	 */
	virtual void PaintStatusImage(IRenderContext* pRender) override;

	/**
	 * @brief ʧȥǷȡѡ
	 * @param[in] bOnSel Ϊ true ʾȡѡfalse Ϊȡ
	 * @return 
	 */
	void SetNoSelOnKillFocus(bool bOnSel);

	/**
	 * @brief ûȡǷѡ
	 * @param[in] bSelAll  true ʾڻȡʱѡݣfalse Ϊѡ
	 * @return 
	 */
	void SetSelAllOnFocus(bool bSelAll);

	/**
	 * @brief ֻģʽʾ
	 * @return 
	 */
	void SetNoCaretReadonly();

	/**
	 * @brief Ӵɫı
	 * @param[in] str ı
	 * @param[in] color ɫֵֵ global.xml д
	 * @return 
	 */
	void AddColorText(const std::wstring &str, const std::wstring &color);

	/**
	 * @brief һɫĳ
	 * @param[in] str 
	 * @param[in] color ɫ
	 * @param[in] linkInfo ӵַ
	 * @return 
	 */
	void AddLinkColorText(const std::wstring &str, const std::wstring &color, const std::wstring &linkInfo = L"");

	/**
	 * @brief һָɫĳ
	 * @param[in] str 
	 * @param[in] color ɫ
	 * @param[in] linkInfo ӵַ
	 * @param[in] font 
	 * @return 
	 */
	void AddLinkColorTextEx(const std::wstring& str, const std::wstring &color, const std::wstring &linkInfo = L"", const std::wstring& strFontId = L"");

	/**
	 * @brief һΧ hittest жǷϢ
	 * @param[in] cr Χʼλúͽλ
	 * @param[in] linkInfo Զ link 
	 * @return 
	 */
	void AddLinkInfo(const CHARRANGE cr, const std::wstring &linkInfo);

	/**
	 * @brief pointhittestԶlink
	 * @param[in] pt λϢ
	 * @param[in] info ʾ link Զ
	 * @return  true ʾ link 
	 */
	bool HittestCustomLink(CPoint pt, std::wstring& info);

	/**
	 * @brief ͼƬ
	 * @return 
	 */
	virtual void ClearImageCache() override;

	/**
	 * @brief س¼
	 * @param[in] callback سµԶص
	 * @return 
	 */
	void AttachReturn(const EventCallback& callback) { OnEvent[kEventReturn] += callback; }

	/**
	 * @brief  TAB ¼
	 * @param[in] callback TAB µԶص
	 * @return 
	 */
	void AttachTab(const EventCallback& callback) {	OnEvent[kEventTab] += callback;	}

	/**
	 * @brief ı޸¼
	 * @param[in] callback ı޸ĺԶص
	 * @return 
	 */
	void AttachTextChange(const EventCallback& callback) { OnEvent[kEventTextChange] += callback; }

	/**
	 * @brief Զӱ¼
	 * @param[in] callback ԶӱԶص
	 * @return 
	 */
	void AttachCustomLinkClk(const EventCallback& callback)	{ OnEvent[kEventCustomLinkClick] += callback; }

	/**
	 * @brief С仯¼
	 * @param[in] callback СıԶص
	 * @return 
	 */
	void AttachGetNaturalSize(const FunGetNaturalSize& callback) { m_cbGetNaturalSize = callback; };
protected:
    CTxtWinHost* m_pTwh;
    bool m_bVScrollBarFixing;
    bool m_bWantTab;
    bool m_bNeedReturnMsg;
    bool m_bReturnMsgWantCtrl;
    bool m_bRich;
    bool m_bReadOnly;
	bool m_bPassword;
    bool m_bWordWrap;
	bool m_bNumberOnly;
	bool m_bInited;
	bool m_bAllowPrompt;
	bool m_bSelAllEver;			//ֻڵһʱȫѡ
	bool m_bNoSelOnKillFocus;	// m_bEnabled && m_bReadOnly
	bool m_bSelAllOnFocus;		// m_bEnabled && !m_bReadOnly
	bool m_bNoCaretReadonly;
	bool m_bIsCaretVisiable;
	bool m_bIsComposition;
	int	 m_iCaretPosX;
	int  m_iCaretPosY;
	int  m_iCaretWidth;
	int  m_iCaretHeight;
	std::wstring m_sFontId;
	int  m_iLimitText;
	LONG m_lTwhStyle;
	VerAlignType m_textVerAlignType;
	std::wstring m_sCurrentColor;
	std::wstring m_sTextColor;
	std::wstring m_sDisabledTextColor;
	std::wstring m_sPromptColor;
	std::wstring m_sCaretColor;
	std::wstring m_sText;
	std::wstring m_sPromptText;
	std::wstring m_sPromptTextId;
	nbase::WeakCallbackFlag m_drawCaretFlag;
	std::weak_ptr<nbase::WeakFlag> m_windowFlag; //¼flag
	FunGetNaturalSize m_cbGetNaturalSize;

protected:
	struct LinkInfo
	{
		CHARRANGE cr;
		std::wstring info;
	};
	std::map<UINT, nbase::WeakCallbackFlag> m_timeFlagMap;
	std::vector<LinkInfo> m_linkInfo;
	Image m_sFocusedImage;
};

//жǷֽڣ ɴӡַ0x20-0x7e
bool IsAsciiChar(const wchar_t ch);
//ȡַֽ
int  GetAsciiCharNumber(const std::wstring &str);
//ɾַгlimitֽڸַ֮
void LimitAsciiNumber(std::wstring &src, int limit);
//ȡճַ
void GetClipboardText(std::wstring &out);
//ճַ
void SetClipBoardText(const std::wstring &str);

} // namespace ui

#endif // UI_CONTROL_RICHEDIT_H_
