#ifndef UI_CONTROL_SCROLLBAR_H_
#define UI_CONTROL_SCROLLBAR_H_

#pragma once

namespace ui
{

class UILIB_API ScrollBar : public Control
{
public:
	ScrollBar();

	Box* GetOwner() const;
	void SetOwner(ScrollableBox* pOwner);

	/// д෽ṩԻܣο
	virtual void SetEnabled(bool bEnable = true) override;
	virtual void SetFocus() override;
	virtual void SetVisible_(bool bVisible) override;
	virtual bool ButtonUp(EventArgs& msg) override;
	virtual bool HasHotState() override;
	virtual bool MouseEnter(EventArgs& msg) override;
	virtual bool MouseLeave(EventArgs& msg) override;
	virtual void SetPos(UiRect rc) override;
	virtual void HandleMessage(EventArgs& event) override;
	virtual void SetAttribute(const std::wstring& strName, const std::wstring& strValue) override;
	virtual void Paint(IRenderContext* pRender, const UiRect& rcPaint) override;
	virtual void ClearImageCache() override;

	/**
	 * @brief Ƿˮƽ
	 * @return  true ˮƽΪ false Ǵֱ
	 */
	bool IsHorizontal();

	/**
	 * @brief ù
	 * @param[in]  true ˮƽ false ǴֱĬΪ true
	 * @return 
	 */
	void SetHorizontal(bool bHorizontal = true);

	/**
	 * @brief ȡΧӦ XML  range 
	 * @return عΧ
	 */
	int64_t GetScrollRange() const;

	/**
	 * @brief ùΧ
	 * @param[in] nRange ҪõĹΧ
	 * @return 
	 */
	void SetScrollRange(int64_t nRange);

	/**
	 * @brief жǷЧ
	 * @return true ΪЧΪ false
	 */
	bool IsValid() { return GetScrollRange() != 0; }

	/**
	 * @brief ȡλ
	 * @return عλ
	 */
	int64_t GetScrollPos() const;

	/**
	 * @brief ùλ
	 * @param[in] nPos ҪõλϢ
	 * @return 
	 */
	void SetScrollPos(int64_t nPos);

	/**
	 * @brief ȡһеĴС
	 * @return عһеĴС
	 */
	int GetLineSize() const;

	/**
	 * @brief ùһеĴС
	 * @param[in] nSize ҪõĴСֵ
	 * @return 
	 */
	void SetLineSize(int nSize);

	/**
	 * @brief ȡС
	 * @return ػС
	 */
	int GetThumbMinLength() const;

	/**
	 * @brief ûС
	 * @param[in] nThumbMinLength ҪõС
	 * @return 
	 */
	void SetThumbMinLength(int nThumbMinLength);

	/**
	 * @brief Ƿʾϰť
	 * @return  true Ϊʾfalse Ϊʾ
	 */
	bool IsShowButton1();

	/**
	 * @brief Ƿʾϰť
	 * @param[in] bShow  true Ϊʾfalse Ϊʾ
	 * @return 
	 */
	void SetShowButton1(bool bShow);

	/**
	 * @brief ȡָ״̬µϰťͼƬ
	 * @param[in] stateType Ҫȡ״̬ο ControlStateType ö
	 * @return ͼƬλ
	 */
	std::wstring GetButton1StateImage(ControlStateType stateType);

	/**
	 * @brief ָ״̬µϰťͼƬ
	 * @param[in] stateType Ҫ״̬µͼƬ
	 * @param[in] pStrImage ͼƬλ
	 * @return 
	 */
	void SetButton1StateImage(ControlStateType stateType, const std::wstring& pStrImage);

	/**
	 * @brief Ƿʾһ°ť
	 * @return  true Ϊʾfalse Ϊʾ
	 */
	bool IsShowButton2();

	/**
	 * @brief Ƿʾһ°ť
	 * @param[in] bShow  true Ϊʾfalse Ϊʾ
	 * @return 
	 */
	void SetShowButton2(bool bShow);

	/**
	 * @brief ȡָ״̬µһ°ťͼƬ
	 * @param[in] stateType Ҫȡ״̬ο ControlStateType ö
	 * @return ͼƬλ
	 */
	std::wstring GetButton2StateImage(ControlStateType stateType);

	/**
	 * @brief ָ״̬µһ°ťͼƬ
	 * @param[in] stateType Ҫ״̬µͼƬ
	 * @param[in] pStrImage ͼƬλ
	 * @return 
	 */
	void SetButton2StateImage(ControlStateType stateType, const std::wstring& pStrImage);

	/**
	 * @brief ȡָ״̬µͼƬ
	 * @param[in] stateType Ҫȡ״̬ʶο ControlStateType ö
	 * @return ͼƬλ
	 */
	std::wstring GetThumbStateImage(ControlStateType stateType);

	/**
	 * @brief ûָ״̬µͼƬ
	 * @param[in] stateType Ҫõ״̬ʶο ControlStateType ö
	 * @param[in] pStrImage ͼƬλ
	 * @return 
	 */
	void SetThumbStateImage(ControlStateType stateType, const std::wstring& pStrImage);

	/**
	 * @brief ȡָ״̬»мʶͼƬ
	 * @param[in] stateType Ҫȡ״̬ʶο ControlStateType ö
	 * @return ͼƬλ
	 */
	std::wstring GetRailStateImage(ControlStateType stateType);

	/**
	 * @brief ָ״̬»мʶͼƬ
	 * @param[in] stateType Ҫõ״̬ʶο ControlStateType ö
	 * @param[in] pStrImage ͼƬλ
	 * @return 
	 */
	void SetRailStateImage(ControlStateType stateType, const std::wstring& pStrImage);

	/**
	 * @brief ȡָ״̬µıͼƬ
	 * @param[in] stateType Ҫȡ״̬ʶο ControlStateType ö
	 * @return ͼƬλ
	 */
	std::wstring GetBkStateImage(ControlStateType stateType);

	/**
	 * @brief ָ״̬µıͼƬ
	 * @param[in] stateType Ҫõ״̬ʶο ControlStateType ö
	 * @param[in] pStrImage ͼƬλ
	 * @return 
	 */
	void SetBkStateImage(ControlStateType stateType, const std::wstring& pStrImage);

	/**
	 * @brief ǷԶع
	 * @return  true ΪǣΪ false
	 */
	bool IsAutoHideScroll(){return m_bAutoHide;}

	/**
	 * @brief ǷԶع
	 * @param[in] hide Ϊ true ΪԶأfalse ΪԶ
	 * @return 
	 */
	void SetAutoHideScroll(bool hide);

	/**
	 * @brief ȡ״̬
	 * @return ػ״̬ο ControlStateType ö
	 */
	ControlStateType GetThumbState() { return m_uThumbState; }

private:
	void ScrollTimeHandle();

	/// غ
	void PaintBk(IRenderContext* pRender);
	void PaintButton1(IRenderContext* pRender);
	void PaintButton2(IRenderContext* pRender);
	void PaintThumb(IRenderContext* pRender);
	void PaintRail(IRenderContext* pRender);

protected:
	enum
	{ 
		DEFAULT_SCROLLBAR_SIZE = 16,
	};

	bool m_bHorizontal;
	bool m_bShowButton1;
	bool m_bShowButton2;
	bool m_bAutoHide;
	int64_t m_nRange;
	int64_t m_nScrollPos;
	int m_nLineSize;
	int m_nThumbMinLength;
	int m_nLastScrollPos;
	int m_nLastScrollOffset;
	int m_nScrollRepeatDelay;
	ScrollableBox* m_pOwner;
	POINT m_ptLastMouse;
	UiRect m_rcButton1;
	UiRect m_rcButton2;
	UiRect m_rcThumb;
	ControlStateType m_uButton1State;
	ControlStateType m_uButton2State;
	ControlStateType m_uThumbState;
	std::wstring m_sImageModify;
	StateImage m_bkStateImage;
	StateImage m_button1StateImage;
	StateImage m_button2StateImage;
	StateImage m_thumbStateImage;
	StateImage m_railStateImage;
	nbase::WeakCallbackFlag m_weakFlagOwner;
};

}

#endif // UI_CONTROL_SCROLLBAR_H_