#ifndef UI_CONTROL_TREEVIEW_H_
#define UI_CONTROL_TREEVIEW_H_

#pragma once

namespace ui
{

#define ROOT_NODE_DEPTH  -1

class TreeView;
class UILIB_API TreeNode : public ListContainerElement
{
public:
	TreeNode();
	TreeNode(const TreeNode& r) = delete;
	TreeNode& operator=(const TreeNode& r) = delete;

	/// д෽ṩԻܣο
	virtual bool IsVisible() const override;
	virtual void SetInternVisible(bool bVisible) override;
	virtual void SetWindow(Window* pManager, Box* pParent, bool bInit = true) override;

	/**
	 * @brief ʱ
	 * @param[in] param Ϣ
	 * @return ʼշ true
	 */
	virtual bool OnClickItem(EventArgs* param);

	/**
	 * @brief б
	 * @param[in] pTreeView ָ
	 * @return 
	 */
	void SetTreeView(TreeView* pTreeView);

	/**
	 * @brief ȡڵָ
	 * @return ظڵָ
	 */
	TreeNode* GetParentNode();

	/**
	 * @brief øڵ
	 * @param[in] pParentTreeNode ڵָ
	 * @return 
	 */
	void SetParentNode(TreeNode* pParentTreeNode);

	/**
	 * @brief ӽڵ
	 * @param[in] pTreeNode ӽڵָ
	 * @return ɹ trueʧܷ false
	 */
	bool AddChildNode(TreeNode* pTreeNode);

	/**
	 * @brief ָλӽڵ
	 * @param[in] pTreeNode ӽڵָ
	 * @param[in] iIndex Ҫĸλ֮
	 * @return ɹ trueʧܷ false
	 */
	bool AddChildNodeAt(TreeNode* pTreeNode, std::size_t iIndex);

	/**
	 * @brief ָλƳһӽڵ
	 * @param[in] index ҪƳӽڵ
	 * @return ɹ trueʧܷ false
	 */
	bool RemoveChildNodeAt(std::size_t index);

	/**
	 * @brief ӽڵָƳһӽڵ
	 * @param[in] pTreeNode ӽڵָ
	 * @return ɹ trueʧܷ false
	 */
	bool RemoveChildNode(TreeNode* pTreeNode);

	/**
	 * @brief Ƴӽڵ
	 * @return 
	 */
	void RemoveAllChildNode();

	/**
	 * @brief ݹȡӽڵ
	 * @return ӽڵ
	 */
	int GetDescendantNodeCount();

	/**
	 * @brief ȡһӽڵ
	 * @return ӽڵ
	 */
	std::size_t GetChildNodeCount();

	/**
	 * @brief ȡһӽڵָ
	 * @param[in] iIndex Ҫȡӽڵ
	 * @return ӽڵָ
	 */
	TreeNode* GetChildNode(std::size_t iIndex);

	/**
	 * @brief ӽڵָȡӽڵλ
	 * @param[in] pTreeNode ӽڵָ
	 * @return λ
	 */
	int	GetChildNodeIndex(TreeNode* pTreeNode);

	/**
	 * @brief жǷչ״̬
	 * @return  true Ϊչ״̬Ϊ false
	 */
	bool IsExpand() const; 

	/**
	 * @brief Ƿչʾӽڵ
	 * @param[in] bExpand Ϊ true ʱչΪ false ǲչ
	 * @return 
	 */
	void SetExpand(bool bExpand);

	/**
	 * @brief ȡ㼶
	 * @return صǰ㼶
	 */
	int GetDepth();

private:
	/**
	 * @brief ɾ
	 * @return ɹ trueʧܷ false
	 */
	bool RemoveSelf();

private:
	int m_iDepth;
	bool m_bExpand;
	TreeView *m_pTreeView;
	TreeNode *m_pParentTreeNode;
	std::vector<TreeNode*> m_aTreeNodes;
};

class UILIB_API TreeView : public ListBox
{
public:
	TreeView(void);

	/// д෽ṩԻܣο
	virtual void SetAttribute(const std::wstring& strName, const std::wstring& strValue) override;

	/**
	 * @brief ȡڵ
	 * @return ظڵָ
	 */
	TreeNode* GetRootNode()	{ return m_rootNode.get(); }

	/**
	 * @brief ȡӽڵֵ
	 * @return ӽڵֵ
	 */
	int GetIndent() { return m_iIndent;	}

	/**
	 * @brief ӽڵֵ
	 * @param[in] indent Ҫõֵ
	 * @return 
	 */
	void SetIndent(int indent) { m_iIndent = indent; }

private:
	//º˽лֹʹãӦʹTreeNodeеغ
	bool Add(Control* pControl) override;
	bool AddAt(Control* pControl, std::size_t iIndex) override;
	bool Remove(Control* pControl) override;
	bool RemoveAt(std::size_t iIndex) override;
	void RemoveAll() override;

	virtual void SetWindow(Window* pManager, Box* pParent, bool bInit = true) override;

private:
	int m_iIndent;
	std::unique_ptr<TreeNode> m_rootNode;
};

}

#endif // UI_CONTROL_TREEVIEW_H_
