#ifndef UI_CORE_BOX_H_
#define UI_CORE_BOX_H_

#pragma once

namespace ui 
{

class Box;
class UILIB_API Layout
{
public:
	Layout();
	Layout& operator=(const Layout& r) = delete;
	virtual ~Layout() {}

	/**
	 * @brief 
	 * @return 
	 */
	void SetOwner(Box* pOwner);

	/**
	 * @brief ø״̬µϢ
	 * @param[in] pControl ؼ
	 * @param[in] rcContainer ҪõλϢ
	 * @return ؿؼյλϢ
	 */
	static CSize SetFloatPos(Control* pControl, UiRect rcContainer);

	/**
	 * @brief ò
	 * @param[in] strName Ҫõ
	 * @param[in] strValue Ҫõֵ
	 * @return true óɹfalse Բ
	 */
	virtual bool SetAttribute(const std::wstring& strName, const std::wstring& strValue);

	/**
	 * @brief ڲпؼλϢ
	 * @param[in] items ؼб
	 * @param[in] rc ǰλϢ
	 * @return кպӵĿȺ͸߶Ϣ
	 */
	virtual CSize ArrangeChild(const std::vector<Control*>& items, UiRect rc);

	/**
	 * @brief ڲӿؼСС
	 * @param[in] items ؼб
	 * @param[in] szAvailable ӿؼ
	 * @return кպӵĿȺ͸߶Ϣ
	 */
	virtual CSize AjustSizeByChild(const std::vector<Control*>& items, CSize szAvailable);

	/**
	 * @brief ȡڱ߾
	 * @return ڱ߾ıߵĴС
	 */
	virtual UiRect GetPadding() const;

	/**
	 * @brief ڱ߾࣬൱ÿͻ
	 * @param[in] rcPadding ڱ߾
	 * @param[in] bNeedDpiScale Ƿ DPI ӦĬΪ true
	 * @return 
	 */
	virtual void SetPadding(UiRect rcPadding, bool bNeedDpiScale = true);

	/**
	 * @brief ȡӿؼ֮Ķ߾
	 * @return ضֵ
	 */
	virtual int GetChildMargin() const;

	/**
	 * @brief ӿؼ֮Ķ߾
	 * @param[in] iMargin Ҫõı߾ֵ
	 * @return 
	 */
	virtual void SetChildMargin(int iMargin);

	/**
	 * @brief ȡڱ߾Ŀ÷Χ
	 * @return ؿ÷ΧλϢ
	 */
	UiRect GetInternalPos() const;

protected:
	UiRect m_rcPadding;
	int m_iChildMargin;
	Box *m_pOwner;
};


/////////////////////////////////////////////////////////////////////////////////////
//
class ScrollBar;

class UILIB_API Box : public Control
{
public:
	Box(Layout* pLayout = new Layout());
	Box(const Box& r);
	Box& operator=(const Box& r) = delete;
    virtual ~Box();

public:
	/// дӿڣṩԻܡ˵鿴 Control ؼ             */
	virtual void SetWindow(Window* pManager, Box* pParent, bool bInit = true) override;
	virtual void SetAttribute(const std::wstring& strName, const std::wstring& strValue) override;
	virtual void SetPos(UiRect rc) override;
	virtual void HandleMessageTemplate(EventArgs& msg) override;
	virtual void PaintChild(IRenderContext* pRender, const UiRect& rcPaint) override;
	virtual void SetVisible_(bool bVisible) override;
	virtual void SetInternVisible(bool bVisible = true) override;
	virtual void SetEnabled(bool bEnabled) override;
	virtual CSize EstimateSize(CSize szAvailable) override;
	virtual Control* FindControl(FINDCONTROLPROC Proc, LPVOID pData, UINT uFlags, CPoint scrollPos = CPoint()) override;
	virtual void InvokeLoadImageCache() override;
	virtual void UnLoadImageCache() override;
	virtual void ClearImageCache() override;
	virtual UINT GetControlFlags() const override;


	/// з
	/**
	 * @brief ָӿؼ
	 * @param[in] pstrSubControlName ӿؼ
	 * @return ӿؼָ
	 */
	Control* FindSubControl(const std::wstring& pstrSubControlName);

	/**
	 * @brief һѡؼ listcombo
	 * @param[in] iIndex ָҪʼҵ
	 * @param[in] bForward true Ϊң false Ϊݼ
	 * @return һѡؼ -1 Ϊûпѡؼ
	 */
	virtual int FindSelectable(int iIndex, bool bForward = true) const;

	/**
	 * @brief ָؼ
	 * @param[in] iIndex ؼ
	 * @return ؿؼָ
	 */
	virtual Control* GetItemAt(std::size_t iIndex) const;

	/**
	 * @brief ݿؼָȡ
	 * @param[in] pControl ؼָ
	 * @return  pControl ָĿؼ
	 */
	virtual int GetItemIndex(Control* pControl) const;

	/**
	 * @brief ÿؼڲпؼλã
	 * @param[in] pControl ؼָ
	 * @param[in] iIndex Ҫõֵ
	 * @return  true óɹfalse ʧ
	 */
	virtual bool SetItemIndex(Control* pControl, std::size_t iIndex);

	/**
	 * @brief ȡӿؼ
	 * @return ӿؼ
	 */
	virtual int GetCount() const;

	/**
	 * @brief һؼ
	 * @param[in] pControl ؼָ
	 * @return  true ӳɹfalse Ϊʧ
	 */
	virtual bool Add(Control* pControl);

	/**
	 * @brief ָλһؼ
	 * @param[in] pControl ؼָ
	 * @param[in] iIndex ڸ֮ؼ
	 * @return  true Ϊӳɹfalse Ϊʧ
	 */
	virtual bool AddAt(Control* pControl, std::size_t iIndex);

	/**
	 * @brief ݿؼָƳһؼ
	 * @param[in] pControl ؼָ
	 * @return  true ΪƳɹfalse ΪƳʧܣؼܲڣ
	 */
	virtual bool Remove(Control* pControl);

	/**
	 * @brief ݿؼƳһؼ
	 * @param[in] iIndex ҪƳĿؼ
	 * @return  true ΪƳɹfalse ΪƳʧܣֵ̫С򳬳ӿؼ
	 */
	virtual bool RemoveAt(std::size_t iIndex);

	/**
	 * @brief Ƴӿؼ
	 * @return 
	 */
	virtual void RemoveAll();

	/**
	 * @brief ӿؼλ
	 * @param[in] pChild1 ӿؼ1 ָ
	 * @param[in] pChild2 ӿؼ2 ָ
	 * @return 
	 */
	void SwapChild(Control* pChild1, Control* pChild2);

	/**
	 * @brief һӿؼλ
	 * @param[in] pChild ؼָ
	 * @param[in] iIndex Ҫõλ
	 * @return 
	 */
	void ResetChildIndex(Control* pChild, std::size_t iIndex);

	/**
	 * @brief жǷԶ
	 * @return true ΪԶ٣false ΪԶ
	 */
    virtual bool IsAutoDestroy() const;

	/**
	 * @brief ÿؼǷԶ
	 * @param[in] bAuto true ΪԶ٣false ΪԶ
	 * @return 
	 */
    virtual void SetAutoDestroy(bool bAuto);

	/**
	 * @brief жϴڹرպǷԶ
	 * @return true ΪԶ٣false ΪԶ
	 */
    virtual bool IsDelayedDestroy() const;

	/**
	 * @brief ôڹرպǷԶ
	 * @param[in] bDelayed true ΪԶ٣false ΪԶ
	 * @return 
	 */
    virtual void SetDelayedDestroy(bool bDelayed);

	/**
	 * @brief ȡǷӦ
	 * @return true ΪӦfalse ΪӦ
	 */
    virtual bool IsMouseChildEnabled() const;

	/**
	 * @brief Ӧ
	 * @param[in] bEnable Ϊ true ΪӦΪ false ΪӦĬΪ true
	 * @return 
	 */
    virtual void SetMouseChildEnabled(bool bEnable = true);

	/**
	 * @brief ȡֶָ
	 * @return Ĳֶָ
	 */
	virtual Layout* GetLayout() const;

	/**
	 * @brief ¹ֶ
	 * @param[in] pLayout ֶָ
	 * @return 
	 */
	virtual void RetSetLayout(Layout* pLayout);

	/**
	 * @brief ȡڱ߾λϢ
	 * @return ڱ߾λϢ
	 */
	virtual	UiRect GetPaddingPos() const;

	/**
	 * @brief ¼
	 * @param[in] eventType ¼
	 * @return callback ָص
	 */
	void AttachBubbledEvent(EventType eventType, const EventCallback& callback)	{ OnBubbledEvent[eventType] += callback; }

private:
	friend WindowBuilder;

	/**
	 * @brief  XML бд Event  BubbleEvent ¼Ĵ
	 * @param[in] eventType ¼
	 * @return callback ָص
	 */
	void AttachXmlBubbledEvent(EventType eventType, const EventCallback& callback) { OnXmlBubbledEvent[eventType] += callback; }

	EventMap OnXmlBubbledEvent;

protected:
	std::unique_ptr<Layout> m_pLayout;
	bool m_bAutoDestroy;
	bool m_bDelayedDestroy;
	bool m_bMouseChildEnabled;
	std::vector<Control*> m_items;
	EventMap OnBubbledEvent;
};

 /// дֱˮƽʹɸ
class UILIB_API ScrollableBox : public Box
{
public:
	ScrollableBox(Layout* pLayout);
	ScrollableBox(const ScrollableBox& r);
	ScrollableBox& operator=(const ScrollableBox& r) = delete;

	virtual void SetAttribute(const std::wstring& pstrName, const std::wstring& pstrValue) override;
	virtual void SetPos(UiRect rc) override;
	virtual void HandleMessage(EventArgs& event) override;
	virtual bool MouseEnter(EventArgs& msg) override;
	virtual bool MouseLeave(EventArgs& msg) override;
	virtual void PaintChild(IRenderContext* pRender, const UiRect& rcPaint) override;
	virtual void SetMouseEnabled(bool bEnable = true) override;
	virtual void SetWindow(Window* pManager, Box* pParent, bool bInit) override;
	virtual Control* FindControl(FINDCONTROLPROC Proc, LPVOID pData, UINT uFlags, CPoint scrollPos = CPoint()) override;
	virtual void ClearImageCache() override;

	/**
	 * @brief ȡλ
	 * @return عλϢ
	 */
	virtual CSize GetScrollPos() const;

	/**
	 * @brief ȡķΧ
	 * @return عķΧϢ
	 */
	virtual CSize GetScrollRange() const;

	/**
	 * @brief ùλ
	 * @param[in] szPos Ҫõλ
	 * @return 
	 */
	virtual void SetScrollPos(CSize szPos);

	/**
	 * @brief ù Y 
	 * @param[in] y Ҫõ Y ֵ
	 * @return 
	 */
	virtual void SetScrollPosY(int y);
	
	/**
	 * @brief ù X 
	 * @param[in] x Ҫõ X ֵ
	 * @return 
	 */
    virtual void SetScrollPosX(int x);
	
	/**
	 * @brief Ϲ
	 * @param[in] deltaValue 룬ĬΪ DUI_NOSET_VALUE
 	 * @param[in] withAnimation Ƿ񸽴ЧĬΪ true
	 * @return 
	 */
	virtual void LineUp(int detaValue = DUI_NOSET_VALUE, bool withAnimation = true);
	
	/**
	 * @brief ¹
	 * @param[in] deltaValue 룬ĬΪ DUI_NOSET_VALUE
 	 * @param[in] withAnimation Ƿ񸽴ЧĬΪ true
	 * @return 
	 */
	virtual void LineDown(int detaValue = DUI_NOSET_VALUE, bool withAnimation = true);
	
	/**
	 * @brief 
	 * @param[in] deltaValue 룬ĬΪ DUI_NOSET_VALUE
	 * @return 
	 */
    virtual void LineLeft(int detaValue = DUI_NOSET_VALUE);
	
	/**
	 * @brief ҹ
	 * @param[in] deltaValue 룬ĬΪ DUI_NOSET_VALUE
	 * @return 
	 */
    virtual void LineRight(int detaValue = DUI_NOSET_VALUE);
	/**
	 * @brief ϹһҳСľ
	 * @return 
	 */
	virtual void PageUp();

	/**
	 * @brief ¹һҳСľ
	 * @return 
	 */
	virtual void PageDown();

	/**
	 * @brief صϷ
	 * @return 
	 */
	virtual void HomeUp();

	/**
	 * @brief ·λ
	 * @param[in] arrange ǷùλãĬΪ true
	 * @param[in] withAnimation ǷЧĬΪ true
	 * @return 
	 */
	virtual void EndDown(bool arrange = true, bool withAnimation = true);
	/**
	 * @brief һҳСľ
	 * @return 
	 */
	virtual void PageLeft();

	/**
	 * @brief ҹһҳСľ
	 * @return 
	 */
	virtual void PageRight();

	/**
	 * @brief 
	 * @return 
	 */
	virtual void HomeLeft();

	/**
	 * @brief Ҳ
	 * @return 
	 */
	virtual void EndRight();

	/**
	 * @brief ϹӦ WM_TOUCH Ϣ
	 * @param[in] deltaValue 
	 * @return 
	 */
	virtual void TouchUp(int deltaValue);

	/**
	 * @brief ¹Ӧ WM_TOUCH Ϣ
	 * @param[in] deltaValue 
	 * @return 
	 */
	virtual void TouchDown(int deltaValue);

	/**
	 * @brief ù
	 * @param[in] bEnableVertical ǷôֱĬΪ true
	 * @param[in] bEnableHorizontal ǷˮƽĬΪ true
	 * @return 
	 */
	virtual void EnableScrollBar(bool bEnableVertical = true, bool bEnableHorizontal = false);

	/**
	 * @brief ȡֱָ
	 * @return شֱָ
	 */
	virtual ScrollBar* GetVerticalScrollBar() const;

	/**
	 * @brief ȡˮƽָ
	 * @return ˮƽָ
	 */
	virtual ScrollBar* GetHorizontalScrollBar() const;

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	virtual void ProcessVScrollBar(UiRect rc, int cyRequired);

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	virtual void ProcessHScrollBar(UiRect rc, int cxRequired);

	/**
	 * @brief жϴֱǷЧ
	 * @return  true ʾЧ false ΪЧ
	 */
	bool IsVScrollBarValid() const;

	/**
	 * @brief жˮƽǷЧ
	 * @return  true ʾЧ false ΪЧ
	 */
	bool IsHScrollBarValid() const;

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	void ReomveLastItemAnimation();

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	void PlayRenderOffsetYAnimation(int nRenderY);

	/**
	 * @brief ǷѾڵײ
	 * @return  true ʾѾڵײΪ false
	 */
	bool IsAtEnd() const;

	/**
	 * @brief Ƿײ
	 * @return  true ʾڵײΪ false
	 */
	bool IsHoldEnd() const;

	/**
	 * @brief ùǷʼײλ
	 * @param[in] bHoldEnd  true ʾfalse Ϊ
	 * @return 
	 */
	void SetHoldEnd(bool bHoldEnd);
	
	/**
	 * @brief ȡֱ
	 * @return ع
	 */
	int GetVerScrollUnitPixels() const;

	/**
	 * @brief ôֱ
	 * @param[in] nUnitPixels ҪõĲ
	 * @return 
	 */
	void SetVerScrollUnitPixels(int nUnitPixels);

	/**
	* @brief ȡ
	* @return ع
	*/
	int GetHorScrollUnitPixels() const;

	/**
	* @brief ú
	* @param[in] nUnitPixels ҪõĲ
	* @return 
	*/
	void SetHorScrollUnitPixels(int nUnitPixels);

	/**
	 * @brief ȡĹǷӿؼ
	 * @return  true ʾڹϣΪ false
	 */
	bool GetScrollBarFloat() const;

	/**
	 * @brief ĹǷӿؼ
	 * @param[in] bScrollBarFloat true ʾڹϣfalse ʾڿؼ
	 * @return 
	 */
	void SetScrollBarFloat(bool bScrollBarFloat);

	/**
	 * @brief ȡ߾
	 * @return ر߾Ϣ 
	 */
	UiRect GetScrollBarPadding() const;

	/**
	 * @brief ù߾࣬ùռ
	 * @param[in] rcScrollBarPadding Ҫõı߾
	 * @return 
	 */
	void SetScrollBarPadding(UiRect rcScrollBarPadding);

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	bool GetDefaultDisplayScrollbar() const;

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	void SetDefaultDisplayScrollbar(bool bDefaultDisplay);

	/**
	 * @brief λñ仯¼
	 * @param[in] callback б仯֪ͨĻص
	 * @return 
	 */
	void AttachScrollChange(const EventCallback& callback) { OnEvent[kEventScrollChange] += callback; }
protected:

	/**
	 * @brief ĳߴ
	 * @param[in] rc ǰλϢ
	 * @return ߴС
	 */
	virtual CSize CalcRequiredSize(const UiRect& rc);

	/**
	 * @brief ͼƬ棬 ScrollableBox ڲʹ
	 * @param[in] bFromTopLeft 
	 * @return 
	 */
	void LoadImageCache(bool bFromTopLeft);
private:
	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	void SetPosInternally(UiRect rc);

protected:
	std::unique_ptr<ScrollBar> m_pVerticalScrollBar;
	std::unique_ptr<ScrollBar> m_pHorizontalScrollBar;

	int m_nVerScrollUnitPixels;
    int m_nHerScrollUnitPixels;
	bool m_bScrollProcess; // ֹSetPosѭ
	bool m_bHoldEnd;
	bool m_bScrollBarFloat;
	bool m_bDefaultDisplayScrollbar;
	UiRect m_rcScrollBarPadding;

	CPoint m_ptLastTouchPos;
	AnimationPlayer m_scrollAnimation;
	AnimationPlayer m_renderOffsetYAnimation;
};

} // namespace ui

#endif // UI_CORE_BOX_H_
