#ifndef UI_CORE_CONTROL_H_
#define UI_CORE_CONTROL_H_

#pragma once

namespace ui 
{

typedef Control* (CALLBACK* FINDCONTROLPROC)(Control*, LPVOID);

class UILIB_API UserDataBase
{
public:
	virtual ~UserDataBase()
	{

	}
};

class UILIB_API Control : public PlaceHolder
{
	typedef std::map<int, CEventSource> GifEventMap;
public:
	Control();
	Control(const Control& r);
	Control& operator=(const Control& r) = delete;
    virtual ~Control();

    /// ͼ
	/**
	 * @brief ȡɫ
	 * @return رɫֵַ global.xml ж
	 */
	std::wstring GetBkColor() const;

	/**
	 * @brief ñɫ
	 * @param[in] strColor Ҫõıɫֵֵ global.xml д
	 * @return 
	 */
	void SetBkColor(const std::wstring& strColor);

	/**
	 * @brief ȡĳ״̬µɫ
	 * @param[in] stateType Ҫȡ״̬µɫֵο ControlStateType ö
	 * @return ָ״̬趨ɫַӦ global.xml ָɫֵ
	 */
	std::wstring GetStateColor(ControlStateType stateType);

	/**
	 * @brief ĳ״̬µɫ
	 * @param[in] stateType Ҫú״̬µɫֵο ControlStateType ö
	 * @param[in] strColor Ҫõɫֵֵ global.xml д
	 * @return 
	 */
	void SetStateColor(ControlStateType stateType, const std::wstring& strColor);

	/**
	 * @brief ȡͼƬλ
	 * @return ͼƬλ  
	 */
    std::wstring GetBkImage() const;

	/**
	 * @brief ȡ UTF8 ʽıͼƬλ
	 * @return ͼƬλ
	 */
	std::string GetUTF8BkImage() const;

	/**
	 * @brief ñͼƬ
	 * @param[in] strImage ҪõͼƬ·
	 * @return 
	 */
    void SetBkImage(const std::wstring& strImage);

	/**
	 * @brief ñͼƬUTF8 ʽַ
	 * @param[in] strImage ҪõͼƬ·
	 * @return 
	 */
	void SetUTF8BkImage(const std::string& strImage);

	/**
	 * @brief ȡָ״̬µͼƬλ
	 * @param[in] Ҫȡ״̬µͼƬο ControlStateType ö
	 * @return ָ״̬µͼƬλ
	 */
	std::wstring GetStateImage(ControlStateType stateType);

	/**
	 * @brief ĳ״̬µͼƬ
	 * @param[in] stateType Ҫú״̬µͼƬο ControlStateType ö
	 * @param[in] strImage ҪõͼƬ·
	 * @return 
	 */
	void SetStateImage(ControlStateType stateType, const std::wstring& strImage);

	/**
	 * @brief ȡָ״̬µǰͼƬ
	 * @param[in] Ҫȡ״̬µͼƬο `ControlStateType` ö
	 * @return ָ״̬ǰͼƬλ
	 */
	std::wstring GetForeStateImage(ControlStateType stateType);

	/**
	 * @brief ĳ״̬ǰͼƬ
	 * @param[in] stateType Ҫú״̬µͼƬο `ControlStateType` ö
	 * @param[in] strImage ҪõǰͼƬ·
	 * @return 
	 */
	void SetForeStateImage(ControlStateType stateType, const std::wstring& strImage);

	/**
	 * @brief ȡؼ״̬
	 * @return ؼ״̬ο `ControlStateType` ö
	 */
	ControlStateType GetState() const;

	/**
	 * @brief ÿؼ״̬
	 * @param[in] pStrState ҪõĿؼ״̬ο `ControlStateType` ö
	 * @return 
	 */
	void SetState(ControlStateType pStrState);

	/**
	 * @brief ȡؼͼƬָ
	 * @return ͼƬָ
	 */
	virtual Image* GetEstimateImage();

	/// ߿
	/**
	 * @brief ȡ߿С
	 * @return ر߿ĴС
	 */
	int GetBorderSize() const;

	/**
	 * @brief ñ߿С
	 * @param[in] nSize Ҫõı߿С
	 * @return 
	 */
	void SetBorderSize(int nSize);

	/**
	 * @brief ȡ߿ɫ
	 * @return ߿ɫַӦ global.xml еľɫֵ
	 */
	std::wstring GetBorderColor() const;

	/**
	 * @brief ñ߿ɫ
	 * @param[in] strBorderColor ñ߿ɫֵֵַ global.xml д
	 * @return 
	 */
	void SetBorderColor(const std::wstring& strBorderColor);

	/**
	 * @brief ñ߿ĴС
	 * @param[in] rc һ `UiRect` ṹı߿С
	 * @return 
	 */
	void SetBorderSize(UiRect rc);

	/**
	 * @brief ȡ߿С
	 * @return ߿ĴС  
	 */
	int GetLeftBorderSize() const;

	/**
	 * @brief ߿С
	 * @param[in] nSize Ҫõ߿С
	 * @return 
	 */
	void SetLeftBorderSize(int nSize);

	/**
	 * @brief ȡ߿С
	 * @return ߿С
	 */
	int GetTopBorderSize() const;

	/**
	 * @brief ö߿С
	 * @param[in] nSize ҪõϷ߿С
	 * @return 
	 */
	void SetTopBorderSize(int nSize);

	/**
	 * @brief ȡҲ߿С
	 * @return Ҳı߿С
	 */
	int GetRightBorderSize() const;

	/**
	 * @brief Ҳ߿С
	 * @param[in] nSize ҪõҲ߿С
	 * @return 
	 */
	void SetRightBorderSize(int nSize);

	/**
	 * @brief ȡ·߿С
	 * @return ·߿С
	 */
	int GetBottomBorderSize() const;

	/**
	 * @brief ·߿С
	 * @param[in] nSize Ҫõ·߿С
	 * @return 
	 */
	void SetBottomBorderSize(int nSize);

	/**
	 * @brief ȡ߿С
	 * @return ĸı߿С
	 */
	CSize GetBorderRound() const;

	/**
	 * @brief ñ߿С
	 * @param[in] cxyRound һ CSize ṹʾĸ߿ĴС
	 * @return 
	 */
	void SetBorderRound(CSize cxyRound);

    /// 
	/**
	 * @brief ȡָ
	 * @return ǰ
	 */
	virtual CursorType GetCursorType() const;

	/**
	 * @brief õǰָ
	 * @param[in] flag Ҫõͣο CursorType ö
	 * @return 
	 */
	void SetCursorType(CursorType flag);

	/**
	 * @brief ȡؼ״̬µʾı
	 * @return صǰ״̬ʾı
	 */
    virtual std::wstring GetToolTipText() const;

	/**
	 * @brief ȡؼ״̬µʾıUTF8 ʽ
	 * @return صǰ״̬ʾı
	 */
	virtual std::string GetUTF8ToolTipText() const;

	/**
	 * @brief ؼʾʾı
	 * @param[in] strText Ҫõı
	 * @return 
	 */
	virtual void SetToolTipText(const std::wstring& strText);

	/**
	 * @brief ؼʾʾıUTF8 ʽ
	 * @param[in] strText Ҫõı
	 * @return 
	 */
	virtual void SetUTF8ToolTipText(const std::string& strText);

	/**
	 * @brief ؼʾʾıļжӦ
	 * @param[in] strTextId ļжӦʾ ID
	 * @return 
	 */
	virtual void SetToolTipTextId(const std::wstring& strTextId);

	/**
	 * @brief ؼʾʾıļжӦ֣UTF8 ʽ
	 * @param[in] strTextId ļжӦʾ ID
	 * @return 
	 */
	virtual void SetUTF8ToolTipTextId(const std::string& strTextId);

	/**
	 * @brief ؼʾı
	 * @param[in] nWidth ҪõĿֵ
	 * @return 
	 */
	virtual void SetToolTipWidth(int nWidth);

	/**
	 * @brief ȡؼʾı
	 * @return ǰʾı
	 */
	virtual int GetToolTipWidth(void) const;

    /// ˵
	/**
	 * @brief ؼǷӦҼ˵Ϣ
	 * @return ؽʾǷӦҼ˵Ϣtrue ӦҼ˵Ϣfalse ӦҼ˵Ϣ
	 */
    virtual bool IsContextMenuUsed() const;

	/**
	 * @brief ÿؼӦҼ˵Ϣ
	 * @param[in] bMenuUsed ǷӦҼ˵Ϣtrue Ϊǣfalse Ϊ
	 * @return 
	 */
    virtual void SetContextMenuUsed(bool bMenuUsed);

    /// ûݣûʹ
	/**
	 * @brief ȡû󶨵ؼַ
	 * @return ؾַ
	 */
    virtual std::wstring GetDataID() const;

	/**
	 * @brief ȡû󶨵ؼַUTF8 ʽ
	 * @return ؾַ
	 */
	virtual std::string GetUTF8DataID() const;				

	/**
	 * @brief һַݵؼ
	 * @param[in] strText Ҫ󶨵ַ
	 * @return 
	 */
    virtual void SetDataID(const std::wstring& strText);

	/**
	 * @brief һַݵؼUTF8 ʽ
	 * @param[in] strText Ҫ󶨵ַ
	 * @return 
	 */
	virtual void SetUTF8DataID(const std::string& strText);	

	/**
	 * @brief ȡû󶨵Զݽṹ
	 * @return û󶨵Զṹָ
	 */
	virtual UserDataBase* GetUserDataBase() const;

	/**
	 * @brief Զݵؼûɼ̳ UserDataBase Ҫ󶨵
	 * @param[in] pUserDataBase ָ
	 * @return 
	 */
	virtual void SetUserDataBase(UserDataBase* pUserDataBase);

    /// һЩҪ
	/**
	 * @brief ÿؼǷɼ
	 * @param[in] bVisible Ϊ true ʱؼɼΪ false ʱؼ
	 * @return 
	 */
    virtual void SetVisible(bool bVisible = true);

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
    virtual void SetInternVisible(bool bVisible = true); // ڲãЩuiӵдھҪд˺

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	virtual void SetVisible_(bool bVisible);

	/**
	 * @brief ؼǷ
	 * @return ؼ״̬ true ؼãΪ false
	 */
    virtual bool IsEnabled() const;

	/**
	 * @brief ÿؼ״̬
	 * @param[in] bEnable Ϊ true ʱؼãΪ false ʱؼΪ״̬򲻿
	 * @return 
	 */
    virtual void SetEnabled(bool bEnable = true);

	/**
	 * @brief ؼǷӦ¼
	 * @return ؿؼǷӦ¼ true Ӧ¼false ΪӦ
	 */
    virtual bool IsMouseEnabled() const;

	/**
	 * @brief ÿؼǷӦ¼
	 * @param[in] bEnable Ϊ true Ӧ¼Ϊ false ʱӦ¼
	 * @return 
	 */
    virtual void SetMouseEnabled(bool bEnable = true);

	/**
	 * @brief ؼǷӦ¼
	 * @return ؿؼǷӦ¼ true Ӧ¼false Ӧ¼
	 */
    virtual bool IsKeyboardEnabled() const;

	/**
	 * @brief ÿؼǷӦ¼
	 * @param[in] bEnable Ϊ true Ӧ¼Ϊ false ʱӦ¼
	 * @return 
	 */
    virtual void SetKeyboardEnabled(bool bEnable = true);

	/**
	 * @brief ؼǷн
	 * @return ؿؼǷм㣬Ϊ true ʱǵǰн㣬Ϊ false ʱؼûн
	 */
    virtual bool IsFocused() const;

	/**
	 * @brief ÿؼȡ
	 * @return 
	 */
    virtual void SetFocus();

	/**
	 * @brief ؿؼıʶжǷӦ TAB л¼
	 * @return ؿؼıʶ
	 */
	virtual UINT GetControlFlags() const;

	/**
	 * @brief ÿؼԶȡ
	 * @return 
	 */
	void SetNoFocus(); // ؼԶҪ㣬KillFocusһ

	/**
	 * @brief жϵǰ꽹Ƿڿؼ
	 * @return 꽹Ƿڿؼϣtrue 꽹ڿؼϣfalse 꽹㲻ڿؼ
	 */
	virtual bool IsMouseFocused() const { return m_bMouseFocused;}

	/**
	 * @brief Ƿ꽹㵽ؼ
	 * @param[in] bMouseFocused Ϊ true ʱ꽹㵽ؼϣΪ false ʱÿؼʧȥ꽹
	 * @return 
	 */
	virtual void SetMouseFocused(bool bMouseFocused) { m_bMouseFocused = bMouseFocused; }

	/**
	 * @brief жϿؼǰǷǼ״̬
	 * @return ؿؼ״̬true ؼǰǼ״̬ɼãfalse ؼǰǼ״̬ܲɼ򱻽
	 */
	virtual bool IsActivatable() const;

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	virtual void Activate();

	/// ؼ
	/**
	 * @brief ָؼ
	 * @param[in] Proc
	 * @param[in] pData
	 * @param[in] uFlags
	 * @param[in] scrollPos
	 * @return ؿؼָ
	 */
    virtual Control* FindControl(FINDCONTROLPROC Proc, LPVOID pData, UINT uFlags, CPoint scrollPos = CPoint());

	/// λ
	/**
	 * @brief ȡؼλ
	 * @param[in] bContainShadow ǷӰĬΪ true ӰΧ false Ϊ
	 * @return ؿؼλϢ
	 */
	virtual	UiRect GetPos(bool bContainShadow = true) const override;

	/**
	 * @brief ÿؼλ
	 * @param[in] rc ؼλõϢ
	 * @return 
	 */
	virtual void SetPos(UiRect rc) override;

	/**
	 * @brief ȡؼ߾
	 * @return ؿؼ߾
	 */
	virtual UiRect GetMargin() const;

	/**
	 * @brief ÿؼ߾
	 * @param[in] rcMargin ؼ߾Ϣ
	 * @param[in] bNeedDpiScale Ƿ߾ DPI 䣬ĬΪ truefalse  DPI
	 * @return 
	 */
	virtual void SetMargin(UiRect rcMargin, bool bNeedDpiScale = true);

	/**
	 * @brief ؼС
	 * @param[in] szAvailable 
	 * @return szAvailable ؼʵʴСͼƬ width  height һΪ autoͼƬմС
	 */
	virtual CSize EstimateSize(CSize szAvailable);

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	virtual CSize EstimateText(CSize szAvailable, bool& bReEstimateSize);

	/**
	 * @brief ָǷڹǰλõķΧ
	 * @param[in] point 
	 * @return ǷڷΧڣtrue ڹǰλ÷Χڣfalse ڹǰλ÷Χ
	 */
	virtual bool IsPointInWithScrollOffset(const CPoint& point) const;

	// Ϣ
	/**
	 * @brief ؼͳһϢڣͳ Windows ϢתΪԶʽϢ
	 * @param[in] eventType	Ϣ
	 * @param[in] wParam	Ϣ
	 * @param[in] lParam	Ϣ
	 * @param[in] tChar		Ϣ
	 * @param[in] mousePos	Ϣ
	 * @return 
	 */
	void HandleMessageTemplate(EventType eventType, WPARAM wParam = 0, LPARAM lParam = 0, TCHAR tChar = 0, CPoint mousePos = CPoint(), FLOAT pressure = 0.0f);

	/**
	 * @brief תϢɷϢ
	 * @param[in] msg Ϣ
	 * @return 
	 */
    virtual void HandleMessageTemplate(EventArgs& msg);

	/**
	 * @brief жϿؼǷ HOT ״̬
	 * @return  true  HOT ״̬ Ϊ false
	 */
	virtual bool HasHotState();

	/**
	 * @brief ÿؼǷӦϢ
	 * @param[in] bRecv Ϊ true ʾӦϢfalse ΪӦ
	 * @return 
	 */
	void SetReceivePointerMsg(bool bRecv) { m_bReceivePointerMsg = bRecv; };
	
	/**
	 * @brief жϿؼǷӦϢ
	 * @return  true ΪӦΪ false
	 */
	bool IsReceivePointerMsg() const { return m_bReceivePointerMsg; };

	/**
	 * @brief ÿؼʧȥʱǷ굯Ϣ
	 * @param[in] bNeed Ϊ true ʾӦϢfalse ΪӦ
	 * @return 
	 */
	void SetNeedButtonUpWhenKillFocus(bool bNeed) { m_bNeedButtonUpWhenKillFocus = bNeed; };

	/**
	 * @brief жϿؼʧȥʱǷ굯Ϣ
	 * @return  true ΪҪfalse ΪҪ
	 */
	bool IsNeedButtonUpWhenKillFocus() const { return m_bNeedButtonUpWhenKillFocus; };

	// 
	/**
	 * @brief ÿؼָ
	 * @param[in] strName Ҫõƣ width
	 * @param[in] strValue Ҫõֵ 100
	 * @return 
	 */
    virtual void SetAttribute(const std::wstring& strName, const std::wstring& strValue);

	/**
	 * @brief ÿؼ class ȫ
	 * @param[in] strClass Ҫõ class ƣƱ global.xml д
	 * @return 
	 */
	void SetClass(const std::wstring& strClass);

	/**
	 * @brief Ӧһб
	 * @param[in] strList бַʾ `width="100" height="30"`
	 * @return 
	 */
    void ApplyAttributeList(const std::wstring& strList);

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	bool OnApplyAttributeList(const std::wstring& strReceiver, const std::wstring& strList, EventArgs* eventArgs);

	/// Ʋ
	/**
	 * @brief ͼƬ·ͼƬϢ
	 * @param[inout] duiImage ʱעͼƬ·ϢɹỺͼƬ¼òĳԱ
	 * @return 
	 */
	void GetImage(Image& duiImage) const;

	/**
	 * @brief ͼƬ
	 * @param[in] pRender 
	 * @param[in] duiImage ͼƬ
	 * @param[in] strModify ͼƬĸ
	 * @param[in] nFade ؼ͸ȣöЧֵڻʱǲϱ仯
	 * @return ɹ trueʧܷ false
	 */
	bool DrawImage(IRenderContext* pRender, Image& duiImage, const std::wstring& strModify = L"", int nFade = DUI_NOSET_VALUE);

	/**
	* @brief ȡĶ
	* @return ػĶ
	*/
	IRenderContext* GetRenderContext();

	/**
	* @brief Ķ
	* @return 
	*/
	void ClearRenderContext();

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	virtual void AlphaPaint(IRenderContext* pRender, const UiRect& rcPaint);
	
	/**
	* @brief ƿؼں
	* @param[in] pRender ָ
	* @param[in] rcPaint ָ
	* @return 
	*/
	virtual void Paint(IRenderContext* pRender, const UiRect& rcPaint);

	/**
	* @brief ƿؼں
	* @param[in] pRender ָ
	* @param[in] rcPaint ָ
	* @return 
	*/
	virtual void PaintChild(IRenderContext* pRender, const UiRect& rcPaint) {};

	/**
	* @brief ǷԻƷΧ
	* @param[in] clip  true ΪҪΪҪƺ
	* @return 
	*/
	void SetClip(bool clip) { m_bClip = clip; };

	/**
	* @brief жǷԻƷΧ
	* @return  true ΪҪfalse ΪҪ
	*/
	bool IsClip() const { return m_bClip; }

	/**
	 * @brief ÿؼ͸
	 * @param[in] alpha 0 ~ 255 ͸ֵ255 Ϊ͸
	 * @return 
	 */
	void SetAlpha(int alpha);

	/**
	 * @brief ȡؼ͸
	 * @return ؿؼ͸
	 */
	int GetAlpha() const { return m_nAlpha;	}

	/**
	 * @brief ؼǷ͸
	 * @return ؿؼǷ͸true ؼǰ͸ԣfalse ؼû͸
	 */
	bool IsAlpha() const { return m_nAlpha != 255; }

	/**
	 * @brief ý״̬͸
	 * @param[in] alpha 0 ~ 255 ͸ֵ255 Ϊ͸
	 * @return 
	 */
	void SetHotAlpha(int nHotAlpha);

	/**
	 * @brief ȡ״̬͸
	 * @return ؿؼ״̬͸
	 */
	int GetHotAlpha() const { return m_nHotAlpha; }

	/**
	 * @brief ȡؼƫ
	 * @return صǰؼĻƫ
	 */
	CPoint GetRenderOffset() const { return m_renderOffset;	}

	/**
	 * @brief ÿؼƫ
	 * @param[in] renderOffset ؼƫ
	 * @return 
	 */
	void SetRenderOffset(CPoint renderOffset);

	/**
	 * @brief ÿؼƫƵ X 
	 * @param[in] renderOffsetX X ֵ
	 * @return 
	 */
	void SetRenderOffsetX(int renderOffsetX);

	/**
	 * @brief ÿؼƫƵ Y 
	 * @param[in] renderOffsetY Y ֵ
	 * @return 
	 */
	void SetRenderOffsetY(int renderOffsetY);

	/// GifͼƬ
	/**
	 * @brief  GIF
	 * @param[in] ֹͣһ֡õһ֡ǰ֡һ֡ο GifStopType ö
	 * @return 
	 */
	void StartGifPlayForUI(GifStopType frame = kGifStopFirst,int playcount = -1);

	/**
	 * @brief ֹͣ GIF
	 * @param[in] transfer Ƿֹͣ¼֪ͨߣο AttachGifPlayStop 
	 * @param[frame] frame Žֹͣһ֡õһ֡ǰ֡һ֡ο GifStopType ö
	 * @return 
	 */
	void StopGifPlayForUI(bool transfer = false, GifStopType frame = kGifStopCurrent);

	/**
	 * @brief  GIF ֪ͨ
	 * @param[in] callback Ҫ GIF ֹͣŵĻص
	 * @return 
	 */
	void AttachGifPlayStop(const EventCallback& callback){ OnGifEvent[m_nVirtualEventGifStop] += callback; };

	/// 
	/**
	 * @brief ȡָ
	 * @return ضָ
	 */
	AnimationManager& GetAnimationManager()	{ return m_animationManager; }

	/// ͼƬ
	/**
	 * @brief ͼƬ
	 * @return 
	 */
	virtual void InvokeLoadImageCache();

	/**
	 * @brief ȡͼƬ
	 * @return 
	 */
	virtual void UnLoadImageCache();

	/**
	 * @brief ͼƬ
	 * @return 
	 */
	virtual void ClearImageCache();

	/**
	 * @brief ؼ¼
	 * @param[in] callback ¼Ļصο EventCallback 
	 * @return 
	 */
	void AttachAllEvents(const EventCallback& callback)	{ OnEvent[kEventAll] += callback; }

	/**
	 * @brief ¼
	 * @param[in] callback ¼Ļصο EventCallback 
	 * @return 
	 */
	void AttachMouseEnter(const EventCallback& callback) { OnEvent[kEventMouseEnter] += callback; }

	/**
	 * @brief 뿪¼
	 * @param[in] callback ¼Ļصο EventCallback 
	 * @return 
	 */
	void AttachMouseLeave(const EventCallback& callback) { OnEvent[kEventMouseLeave] += callback; }

	/**
	 * @brief ¼
	 * @param[in] callback ¼Ļصο EventCallback 
	 * @return 
	 */
	void AttachMouseHover(const EventCallback& callback) { OnEvent[kEventMouseHover] += callback; }

	/**
	 * @brief 갴¼
	 * @param[in] callback ¼Ļصο EventCallback 
	 * @return 
	 */
	void AttachButtonDown(const EventCallback& callback) { OnEvent[kEventMouseButtonDown] += callback; }

	/**
	 * @brief 굯¼
	 * @param[in] callback ¼Ļصο EventCallback 
	 * @return 
	 */
	void AttachButtonUp(const EventCallback& callback) { OnEvent[kEventMouseButtonUp] += callback; }

	/**
	 * @brief ý¼
	 * @param[in] callback ¼Ļصο EventCallback 
	 * @return 
	 */
	void AttachSetFocus(const EventCallback& callback) { OnEvent[kEventSetFocus] += callback; }

	/**
	 * @brief ʧȥ¼
	 * @param[in] callback ¼Ļصο EventCallback 
	 * @return 
	 */
	void AttachKillFocus(const EventCallback& callback) { OnEvent[kEventKillFocus] += callback; }

	/**
	 * @brief Ҽ˵¼
	 * @param[in] callback ¼Ļصο EventCallback 
	 * @return 
	 */
	void AttachMenu(const EventCallback& callback) { OnEvent[kEventMouseMenu] += callback; }

	/**
	 * @brief ؼСı¼
	 * @param[in] callback ¼Ļصο EventCallback 
	 * @return 
	 */
	void AttachResize(const EventCallback& callback) { OnEvent[kEventResize] += callback; }

	/**
	 * @brief ȡָ¼ EventType ö
	 * @param[in] callback ¼Ļصο EventCallback 
	 * @return 
	 */
	void DetachEvent(EventType type);

protected:
	friend WindowBuilder;
	void AttachXmlEvent(EventType eventType, const EventCallback& callback) { OnXmlEvent[eventType] += callback; }
	/// GifͼƬ
	void GifPlay();
	void StopGifPlay(GifStopType frame = kGifStopCurrent);

	
	/// ϢıԱⲿֱӵ
	virtual void HandleMessage(EventArgs& msg);
	virtual bool MouseEnter(EventArgs& msg);
	virtual bool MouseLeave(EventArgs& msg);
	virtual bool ButtonDown(EventArgs& msg);
	virtual bool ButtonUp(EventArgs& msg);

	/// رԱⲿֱӵ
	virtual void PaintBkColor(IRenderContext* pRender);
	virtual void PaintBkImage(IRenderContext* pRender);
	virtual void PaintStatusColor(IRenderContext* pRender);
	virtual void PaintStatusImage(IRenderContext* pRender);
	virtual void PaintText(IRenderContext* pRender);
	virtual void PaintBorder(IRenderContext* pRender);

private:
	void BroadcastGifEvent(int nVirtualEvent);
	int GetGifFrameIndex(GifStopType frame);

protected:
	EventMap OnXmlEvent;
	EventMap OnEvent;
	GifEventMap OnGifEvent;
	std::unique_ptr<UserDataBase> m_pUserDataBase;
	bool m_bMenuUsed;
	bool m_bEnabled;
	bool m_bMouseEnabled;
	bool m_bKeyboardEnabled;
	bool m_bFocused;
	bool m_bMouseFocused;
	bool m_bSetPos;		// ֹSetPosѭ
	bool m_bNoFocus;	//ؼҪ
	bool m_bClip;
	bool m_bGifPlay;
	bool m_bReceivePointerMsg;
	bool m_bNeedButtonUpWhenKillFocus;
	int m_nBorderSize;
	int m_nTooltipWidth;
	int m_nAlpha;
	int m_nHotAlpha;
	CSize m_szEstimateSize;
	CPoint m_renderOffset;
	CSize m_cxyBorderRound;
	UiRect m_rcMargin;
	UiRect m_rcPaint;
	UiRect m_rcBorderSize;
	CursorType m_cursorType;	//Ӱؼ״
	ControlStateType m_uButtonState;
	std::wstring m_sToolTipText;
	std::wstring m_sToolTipTextId;
	std::wstring m_sUserData;
	std::wstring m_strBkColor;
	StateColorMap m_colorMap;
	Image m_bkImage;
	StateImageMap m_imageMap;
	std::wstring m_strBorderColor;
	nbase::WeakCallbackFlag m_gifWeakFlag;
	AnimationManager m_animationManager;
	nbase::WeakCallbackFlag m_loadBkImageWeakFlag;
	static const int m_nVirtualEventGifStop;
};

} // namespace ui

#endif // UI_CORE_CONTROL_H_
