#ifndef UI_CORE_WINDOWHELPER_H_
#define UI_CORE_WINDOWHELPER_H_

#pragma once

#include "Image.h"
#include "Window.h"

namespace ui 
{
/**
* @brief ȫԹ
* ڹһЩȫԵĹ࣬ȫʽglobal.xmlõ
*/
class UILIB_API GlobalManager
{
public:
	/**
	 * @brief ʼȫú
	 * @param[in] strResourcePath Դ·λ
	 * @param[in] callback Զؼʱȫֻص
	 * @param[in] bAdaptDpi Ƿ DPI 
	 * @param[in] theme Ŀ¼ĬΪ themes\\default
	 * @param[in] language ʹԣĬΪ lang\\zh_CN
	 * @return 
	 */
	static void Startup(const std::wstring& strResourcePath, const CreateControlCallback& callback, bool bAdaptDpi, const std::wstring& theme = L"themes\\default", const std::wstring& language = L"lang\\zh_CN");

	/**
	 * @brief ͷԴ
	 * @return 
	 */
	static void Shutdown();

	/**
	 * @brief ȡǰĿ¼
	 * @return صǰĿ¼
	 */
	static std::wstring GetCurrentPath();

	/**
	 * @brief ȡǰԴĿ¼
	 * @return صǰԴĿ¼
	 */
	static std::wstring GetResourcePath();

	/**
	 * @brief óǰĿ¼
	 * @param[in] strPath Ҫõ·
	 * @return 
	 */
	static void SetCurrentPath(const std::wstring& strPath);

	/**
	 * @brief ƤԴĿ¼
	 * @param[in] strPath Ҫõ·
	 * @return 
	 */
	static void SetResourcePath(const std::wstring& strPath);

	/**
	 * @brief ¼ƤԴ
	 * @param[in] resourcePath Դ·
	 * @return 
	 */
	static void ReloadSkin(const std::wstring& resourcePath);

	/**
	 * @brief ȡƽӿ
	 * @return ؽӿָ
	 */
	static IRenderFactory* GetRenderFactory();

	/**
	 * @brief ȫֵĻ
	 * @return ػ
	 */
	static std::unique_ptr<IRenderContext> CreateRenderContext();

	/**
	 * @brief һ
	 * @param[in] color ɫ
	 * @param[in] width ʿ
	 * @return ػʶ
	 */
	static std::unique_ptr<IPen> CreatePen(DWORD color, int width = 1);

	/**
	 * @brief һˢ
	 * @param[in] color ˢɫ
	 * @return ػˢ
	 */
	static std::unique_ptr<IBrush> CreateBrush(DWORD color);

	/**
	 * @brief һ
	 * @return ؾ
	 */
	static std::unique_ptr<IMatrix> CreateMatrix();

	/**
	 * @brief һ·
	 * @return ػ·
	 */
	static std::unique_ptr<IPath> CreatePath();

	/**
	 * @brief һȫ class 
	 * @param[in] strClassName ȫ class 
	 * @param[in] strControlAttrList бҪ XML ת
	 * @return 
	 */
	static void AddClass(const std::wstring& strClassName, const std::wstring& strControlAttrList);

	/**
	 * @brief ȡһȫ class Եֵ
	 * @param[in] strClassName ȫ class 
	 * @return ַʽ class ֵ
	 */
	static std::wstring GetClassAttributes(const std::wstring& strClassName);

	/**
	 * @brief ȫɾ class 
	 * @return ػ
	 */
	static void RemoveAllClasss();

	/**
	 * @brief һȫɫֵṩʹ
	 * @param[in] strName ɫƣ white
	 * @param[in] strValue ɫֵ #FFFFFFFF
	 * @return 
	 */
	static void AddTextColor(const std::wstring& strName, const std::wstring& strValue);

	/**
	 * @brief ƻȡһɫľֵ
	 * @param[in] strName Ҫȡɫ
	 * @return  DWORD ʽɫֵ
	 */
	static DWORD GetTextColor(const std::wstring& strName);

	/**
	 * @brief ɾȫɫ
	 * @return 
	 */
	static void RemoveAllTextColors();

	/**
	 * @brief ָͼƬǷѾ
	 * @param[in] bitmap ͼƬ·
	 * @return Ѿ棬򷵻 ImageInfo ָ
	 */
	static std::shared_ptr<ImageInfo> IsImageCached(const std::wstring& bitmap);

	/**
	 * @brief һͼƬ
	 * @param[in] shared_image
	 * @return ر ImageInfo ָ
	 */
	static std::shared_ptr<ImageInfo> AddImageCached(const std::shared_ptr<ImageInfo>& shared_image);

	/**
	 * @brief ӻһһͼƬ
	 * @param[in] imageFullPath ͼƬ·
	 * @return 
	 */
	static void RemoveFromImageCache(const std::wstring& imageFullPath);

	/**
	 * @brief ͼƬٵĻص
	 * @param[in] pImageInfo ͼƬӦ ImageInfo 
	 * @return 
	 */
	static void OnImageInfoDestroy(ImageInfo *pImageInfo);

	/**
	 * @brief ȡͼƬ ImageInfo 
	 * @param[in] bitmap ͼƬ·
	 * @return ͼƬ ImageInfo ָ
	 */
	static std::shared_ptr<ImageInfo> GetImage(const std::wstring& bitmap);

	/**
	 * @brief ӻɾͼƬ
	 * @return 
	 */
	static void RemoveAllImages();

	/**
	 * @brief ȡĬ
	 * @return 
	 */
	static std::wstring GetDefaultFontName();

	/**
	 * @brief һ
	 * @param[in] strFontId ָID
	 * @param[in] strFontName 
	 * @param[in] nSize С
	 * @param[in] bBold Ƿ
	 * @param[in] bUnderline Ƿ»
	 * @param[in] bItalic Ƿб
	 * @param[in] bDefault ǷĬ
	 * @return  HFONT 
	 */
	static HFONT AddFont(const std::wstring& strFontId, const std::wstring& strFontName, int nSize, bool bBold, bool bUnderline, bool bItalic, bool bDefault);

	/**
	 * @brief һϢ
	 * @param[in] strFontId ID
	 * @return  TFontInfo Ϣ
	 */
	static TFontInfo* GetTFontInfo(const std::wstring& strFontId);

	/**
	 * @brief IDһ
	 * @param[in] strFontId ID
	 * @return  HFONT 
	 */
	static HFONT GetFont(const std::wstring& strFontId);
	/**
	 * @brief Իȡ
	 * @param[in] strFontName 
	 * @param[in] nSize С
	 * @param[in] bBold Ƿ
	 * @param[in] bUnderline Ƿ»
	 * @param[in] bItalic Ƿб
	 * @return  HFONT 
	 */
	static HFONT GetFont(const std::wstring& strFontName, int nSize, bool bBold, bool bUnderline, bool bItalic);

	/**
	 * @brief ȡϢ
	 * @param[in] strFontId ID
	 * @param[in] hDcPaint 豸
	 * @return  TFontInfo Ϣ
	 */
	static TFontInfo* GetFontInfo(const std::wstring& strFontId, HDC hDcPaint);

	/**
	 * @brief ȡϢ
	 * @param[in] hFont 
	 * @param[in] hDcPaint 豸
	 * @return  TFontInfo Ϣ
	 */
	static TFontInfo* GetFontInfo(HFONT hFont, HDC hDcPaint);

	/**
	 * @brief ָǷ
	 * @param[in] hFont 
	 * @return Ƿ
	 *     @retval true 
	 *     @retval false 
	 */
	static bool FindFont(HFONT hFont);

	/**
	 * @brief ϢǷ
	 * @param[in] strFontName 
	 * @param[in] nSize С
	 * @param[in] bBold Ƿ
	 * @param[in] bUnderline Ƿ»
	 * @param[in] bItalic Ƿб
	 * @return Ƿ
	 *     @retval true 
	 *     @retval false 
	 */
	static bool FindFont(const std::wstring& strFontName, int nSize, bool bBold, bool bUnderline, bool bItalic);

	/**
	 * @brief ɾ
	 * @param[in] strFontId ID
	 * @return Ƿɾɹ
	 *     @retval true ɾɹ
	 *     @retval false 岻ڻɾʧ
	 */
	static bool RemoveFontAt(const std::wstring& strFontId);

	/**
	 * @brief ɾ
	 * @return 
	 */
	static void RemoveAllFonts();

	/**
	 * @brief ȡĬϽ״̬ɫ
	 * @return ĬϽ״̬ɫַʾӦ global.xml ָɫֵ
	 */
	static std::wstring GetDefaultDisabledTextColor();

	/**
	 * @brief ĬϽ״̬µɫ
	 * @param[in] dwColor ɫֵַ white
	 * @return 
	 */
	static void SetDefaultDisabledTextColor(const std::wstring& strColor);

	/**
	 * @brief ȡĬɫ
	 * @return ĬɫַʾӦ global.xml ָɫֵ
	 */
	static std::wstring GetDefaultTextColor();

	/**
	 * @brief Ĭɫ
	 * @param[in] ɫֵַӦ global.xml ָɫֵ
	 * @return 
	 */
	static void SetDefaultTextColor(const std::wstring& strColor);

	/**
	 * @brief ȡĬɫ
	 * @return ɫ DWORD ʽɫֵ
	 */
	static DWORD GetDefaultLinkFontColor();

	/**
	 * @brief Ĭɫ
	 * @param[in] dwColor Ĭɫ
	 * @return 
	 */
	static void SetDefaultLinkFontColor(DWORD dwColor);

	/**
	 * @brief ȡӵĬɫ
	 * @return ؽӵĬɫ
	 */
	static DWORD GetDefaultLinkHoverFontColor();

	/**
	 * @brief ýӵĬɫ
	 * @param[in] dwColor ӵĬɫ
	 * @return 
	 */
	static void SetDefaultLinkHoverFontColor(DWORD dwColor);

	/**
	 * @brief ȡĬѡ״̬ɫ
	 * @return Ĭѡ״̬ɫ
	 */
	static DWORD GetDefaultSelectedBkColor();

	/**
	 * @brief Ĭѡ״̬ɫ
	 * @param[in] dwColor ɫֵ
	 * @return 
	 */
	static void SetDefaultSelectedBkColor(DWORD dwColor);

	/**
	 * @brief  XML һ Box
	 * @param[in] strXmlPath XML ļ·
	 * @param[in] callback ԶؼĻص
	 * @return ָģĶָ
	 */
	static Box* CreateBox(const std::wstring& strXmlPath, CreateControlCallback callback = CreateControlCallback());

	/**
	 * @brief  XML ڻвָ Boxû򴴽
	 * @param[in] strXmlPath XML ļ·
	 * @param[in] callback ԶؼĻص
	 * @return ָģĶָ
	 */
	static Box* CreateBoxWithCache(const std::wstring& strXmlPath, CreateControlCallback callback = CreateControlCallback());

	/**
	 * @brief ʹ XML ָ Box
	 * @param[in] pUserDefinedBox Ҫ box ָ
	 * @param[in] strXmlPath XML ļ·
	 * @param[in] callback ԶؼĻص
	 * @return 
	 */
	static void FillBox(Box* pUserDefinedBox, const std::wstring& strXmlPath, CreateControlCallback callback = CreateControlCallback());

	/**
	 * @brief ʹùĻָ Boxû¹
	 * @param[in] pUserDefinedBox Ҫ box ָ
	 * @param[in] strXmlPath XML ļ·
	 * @param[in] callback ԶؼĻص
	 * @return 
	 */
	static void FillBoxWithCache(Box* pUserDefinedBox, const std::wstring& strXmlPath, CreateControlCallback callback = CreateControlCallback());

	/**
	 * @brief Զؼȫֻص
	 * @param[in] strControlName Զؼ
	 * @return һԶؼĶָ
	 */
	static Control* CreateControl(const std::wstring& strControlName);

	/**
	 * @brief жϵǰǷʹ zip ѹ
	 * @return  true ʾʹ zip ѹΪԴfalse ΪͨĿ¼ģʽ
	 */
	static bool IsUseZip();

	/**
	 * @brief һڴѹԴ
	 * @param[in] resource_name Դƣ MAKEINTRESOURCE 
	 * @param[in] resource_type ԴͣԶ嵼Դ
	 * @param[in] password ѹ
	 * @return  true 򿪳ɹ false Ϊʧ
	 */
	static bool OpenResZip(LPCTSTR  resource_name, LPCTSTR  resource_type, const std::string& password);

	/**
	 * @brief һļѹԴ
	 * @param[in] path ѹļ·
	 * @param[in] password ѹ
	 * @return  true 򿪳ɹ false Ϊʧ
	 */
	static bool OpenResZip(const std::wstring& path, const std::string& password);

	/**
	 * @brief ȡѹеݵڴ
	 * @param[in] path Ҫȡļ·
	 * @return ļڴַ
	 */
	static HGLOBAL GetData(const std::wstring& path);

	/**
	 * @brief ȡļѹеλ
	 * @param[in] path Ҫȡļ·
	 * @return ѹеļλ
	 */
	static std::wstring GetZipFilePath(const std::wstring& path);

private:
	/**
	 * @brief ȫԴ
	 * @return 
	 */
	static void LoadGlobalResource();

private:
	static std::unique_ptr<IRenderFactory> m_renderFactory;
	class ImageCacheKeyCompare
	{
	public:
		// ȽϺǱȽֵģǰ·
		// ȱȽϣСĸС
		// ȽϣΪֵ
		bool operator()(const std::wstring& key1, const std::wstring& key2) const;
	};
	typedef std::map<std::wstring, std::weak_ptr<ImageInfo>, ImageCacheKeyCompare> MapStringToImagePtr;

	static std::wstring m_pStrResourcePath; //ȫֵԴ·ʱ޸
	static std::vector<Window*> m_aPreMessages;
	static std::map<std::wstring, std::unique_ptr<WindowBuilder>> m_builderMap;
	static CreateControlCallback m_createControlCallback;

	static MapStringToImagePtr m_mImageHash;
	static std::map<std::wstring, DWORD> m_mapTextColor;
	static std::map<std::wstring, std::wstring> m_mGlobalClass;
	static std::map<std::wstring, TFontInfo*> m_mCustomFonts;

	static std::wstring m_sDefaultFontId;

	static short m_H;
	static short m_S;
	static short m_L;

	static std::wstring m_strDefaultFontName;
	static std::wstring m_strDefaultDisabledColor;
	static std::wstring m_strDefaultFontColor;
	static DWORD m_dwDefaultLinkFontColor;
	static DWORD m_dwDefaultLinkHoverFontColor;
	static DWORD m_dwDefaultSelectedBkColor;
};

} // namespace ui

#endif // UI_CORE_WINDOWHELPER_H_
