#ifndef UI_CORE_PLACE_HOLDER_H_
#define UI_CORE_PLACE_HOLDER_H_

#pragma once

namespace ui 
{

class UILIB_API PlaceHolder : public virtual nbase::SupportWeakCallback
{
public:
	PlaceHolder();
	PlaceHolder(const PlaceHolder& r);
	PlaceHolder& operator=(const PlaceHolder& r) = delete;
	virtual ~PlaceHolder();

	/**
	 * @brief ȡָ
	 * @return ظָ
	 */
	Box* GetParent() const { return m_pParent;}

	/**
	 * @brief ƻȡָ
	 * @param[in] strName Ҫȡ
	 * @return ָ
	 */
	Box* GetAncestor(const std::wstring& strName);

	/**
	 * @brief ȡؼƣӦ xml  name 
	 * @return ؿؼ
	 */
	std::wstring GetName() const;

	/**
	 * @brief ȡؼƣӦ xml  name 
	 * @return ؿؼƣUTF8 룩
	 */
	std::string GetUTF8Name() const;

	/**
	 * @brief ÿؼƣڴòд xml 
	 * @param[in] strName Ҫõ
	 * @return 
	 */
	void SetName(const std::wstring& strName);

	/**
	 * @brief ÿؼƣڴòд xml УUTF8 룩
	 * @param[in] strName Ҫõ
	 * @return 
	 */
	void SetUTF8Name(const std::string& strName);

	/**
	 * @brief ȡĴָ
	 * @return عڵָ
	 */
	virtual Window* GetWindow() const;

	/**
	 * @brief 
	 * @param[in] pManager ָ
	 * @param[in] pParent 
	 * @param[in] bInit úǷ Init ʼؼ
	 * @return 
	 */
	virtual void SetWindow(Window* pManager, Box* pParent, bool bInit = true);

	/**
	 * @brief 
	 * @param[in] pManager ָ
	 * @return 
	 */
	virtual void SetWindow(Window* pManager);

	/**
	 * @brief ʼ
	 * @return 
	 */
	virtual void Init();

	/**
	 * @brief  Init ã Init ͬ
	 * @return 
	 */
	virtual void DoInit();

	/**
	 * @brief жǷɼ
	 * @return  true Ϊɼ false Ϊɼ
	 */
	virtual bool IsVisible() const;

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	bool IsInternVisible() const;

	/**
	 * @brief жϿؼǷ񸡶Ӧ xml  float 
	 * @return  true Ǹ״̬ false ΪǸ״̬
	 */
	bool IsFloat() const;

	/**
	 * @brief ÿؼǷ񸡶
	 * @param[in] bFloat Ϊ true Ϊfalse Ϊ
	 * @return 
	 */
	void SetFloat(bool bFloat = true);

	/**
	 * @brief ȡ̶ȣӦ xml  width 
	 * @return ؿؼ
	 */
	int GetFixedWidth() const;

	/**
	 * @brief ÿؼ̶
	 * @param[in] cx ҪõĿ
	 * @param[in] bArrange ǷУĬΪ true
	 * @param[in] bNeedDpiScale  DPI ţĬΪ true
	 * @return 
	 */
	void SetFixedWidth(int cx, bool bArrange = true, bool bNeedDpiScale = true);

	/**
	 * @brief ȡ̶߶
	 * @return ع̶߶
	 */
	int GetFixedHeight() const;

	/**
	 * @brief ù̶߶
	 * @param[in] cy ҪõĹ̶߶
	 * @param[in] bNeedDpiScale  DPI ţĬΪ true
	 * @return 
	 */
	void SetFixedHeight(int cy, bool bNeedDpiScale = true);

	/**
	 * @brief ȡС
	 * @return С
	 */
	int GetMinWidth() const;

	/**
	 * @brief С
	 * @param[in] cx ҪõС
	 * @return 
	 */
	void SetMinWidth(int cx);

	/**
	 * @brief ȡ
	 * @return 
	 */
	int GetMaxWidth() const;

	/**
	 * @brief 
	 * @param[in] cx Ҫõ
	 * @return 
	 */
	void SetMaxWidth(int cx);

	/**
	 * @brief ȡС߶
	 * @return С߶
	 */
	int GetMinHeight() const;

	/**
	 * @brief С߶
	 * @param[in] cy ҪõС߶
	 * @return 
	 */
	void SetMinHeight(int cy);

	/**
	 * @brief ȡ߶
	 * @return ߶
	 */
	int GetMaxHeight() const;

	/**
	 * @brief ߶
	 * @param[in] cy Ҫõ߶
	 * @return 
	 */
	void SetMaxHeight(int cy);

	/**
	 * @brief ȡʵʿ
	 * @return ʵʿ
	 */
	int GetWidth() const;

	/**
	 * @brief ȡʵʸ߶
	 * @return ʵʸ߶
	 */
	int GetHeight() const;

	/**
	 * @brief ȡˮƽ뷽ʽ
	 * @return ˮƽ뷽ʽο HorAlignType ö
	 */
	HorAlignType GetHorAlignType() const;

	/**
	 * @brief ˮƽ뷽ʽ
	 * @param[in] horAlignType ҪõĶ뷽ʽο HorAlignType ö
	 * @return 
	 */
	void SetHorAlignType(HorAlignType horAlignType);

	/**
	 * @brief ȡֱ뷽ʽ
	 * @return شֱ뷽ʽμ VerAlignType ö
	 */
	VerAlignType GetVerAlignType() const;

	/**
	 * @brief ôֱ뷽ʽ
	 * @param[in] vorAlignType ҪõĶ뷽ʽο VerAlignType ö
	 * @return 
	 */
	void SetVerAlignType(VerAlignType verAlignType);

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	bool IsReEstimateSize() const;

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	void SetReEstimateSize(bool bReEstimateSize);

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	virtual CSize EstimateSize(CSize szAvailable);

	/**
	 * @brief ȡؼλ
	 * @param[in] bContainShadow ǷӰλãĬΪ true
	 * @return ؿؼλ
	 */
	virtual	UiRect GetPos(bool bContainShadow = true) const;

	/**
	 * @brief ÿؼλ
	 * @param[in] rc ҪõλϢ
	 * @return 
	 */
	virtual void SetPos(UiRect rc);

	/**
	 * @brief в
	 * @return 
	 */
	virtual void Arrange();

	/**
	 * @brief ø
	 * @return 
	 */
	virtual void ArrangeAncestor();

	/**
	 * @brief жǷѾй
	 * @return true ΪѾйfalse Ϊδ
	 */
	bool IsArranged() const;

	void SetUseCache(bool cache);
	bool IsUseCache() { return m_bUseCache; }
	void SetCacheDirty(bool dirty);
	bool IsCacheDirty() { return m_bUseCache && m_bCacheDirty; }

	/**
	 * @brief ػؼ
	 * @return 
	 */
	virtual void Invalidate();

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	UiRect GetPosWithScrollOffset() const;

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	CPoint GetScrollOffset() const;

	static bool IsChild(PlaceHolder* pAncestor, PlaceHolder* pChild);
protected:
	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	virtual void ArrangeSelf();

protected:
	std::wstring m_sName;
	Window *m_pWindow;
	Box* m_pParent;
	CSize m_cxyFixed;
	CSize m_cxyMin;
	CSize m_cxyMax;
	UiRect m_rcItem;
	HorAlignType m_horAlignType;
	VerAlignType m_verAlignType;
	bool m_bFloat;
	bool m_bReEstimateSize;
	bool m_bVisible;
	bool m_bInternVisible;
	bool m_bIsArranged;

	bool m_bUseCache;
	bool m_bCacheDirty;
	std::unique_ptr<IRenderContext> m_renderContext;
};

} // namespace ui

#endif // UI_CORE_PLACE_HOLDER_H_
