#ifndef UI_UTILS_DPIMANAGER_H_
#define UI_UTILS_DPIMANAGER_H_

#pragma once

namespace ui
{
/** @class DpiManager
  * @brief DPI
  * @copyright (c) 2016, NetEase Inc. All rights reserved
  * @author Redrain
  * @date 2016/10/10
  */
class UILIB_API DpiManager
{
public:
	static DpiManager* GetInstance();

	/**
	* @brief ȡϵͳDPIDPI֪Ч
	* @return UINT DPI
	*/
	static UINT GetSystemDPI();

	/**
	* @brief ȡĳʾDPIDPI֪Ч
	* @param[in] HMONITOR
	* @return UINT DPI
	*/
	static UINT GetMonitorDPI(HMONITOR hMonitor);

	/**
	* @brief ȡʾDPIDPI֪Ч
	* @return UINT DPI
	*/
	static UINT GetMainMonitorDPI();
		
	/**
	* @brief עȡDPIDPI֪ҲЧ
	* @return UINT DPI
	*/
	static UINT GetDPIFromRegistry();

	/**
	* @brief ǷԼDPIЧ
	* @return bool true ǣfalse 
	*/
	bool IsAdaptDPI();

	/**
	* @brief ǷԼDPIţĬϲԼ
	* @return bool true óɹfalse ʧ
	*/
	bool SetAdaptDPI();

	/**
	* @brief ȡǰű
	* @return UINT	ű
	*/
	UINT GetScale();

	/**
	* @brief DPIֵýűȣֻгԼDPIʱЧ
	* @param[in] uDPI DPIֵ
	* @return void	޷ֵ
	*/
	void SetScale(UINT uDPI);

	/**
	* @brief ݽűֻгԼDPIʱЧ
	* @param[in] iValue 
	* @return int	źֵ
	*/
	int ScaleInt(int &iValue);

	/**
	* @brief ݽűSIZEֻгԼDPIʱЧ
	* @param[in] pSize SIZEָ
	* @return void	޷ֵ
	*/
	void ScaleSize(SIZE &size);

	void ScaleSize(CSize &size);

	/**
	* @brief ݽűPOINTֻгԼDPIʱЧ
	* @param[in] pSize SIZEָ
	* @return void	޷ֵ
	*/
	void ScalePoint(POINT &point);

	void ScalePoint(CPoint &point);

	/**
	* @brief ݽűRECTֻгԼDPIʱЧ
	* @param[in] pSize SIZEָ
	* @return void	޷ֵ
	*/
	void ScaleRect(RECT &rect);

	void ScaleRect(UiRect &rect);

private:
	DpiManager();
	~DpiManager() {};	
	DpiManager(const DpiManager&) = delete;
	DpiManager& operator = (const DpiManager&) = delete;

private:
	int		m_nScaleFactor;
	bool	m_bAdaptDPI;
};
}
#endif //UI_UTILS_DPIMANAGER_H_