#ifndef UI_UTILS_WINIMPLBASE_H_
#define UI_UTILS_WINIMPLBASE_H_

#pragma once

namespace ui
{

#define UI_WNDSTYLE_FRAME		(WS_VISIBLE | WS_OVERLAPPEDWINDOW)
#define UI_WNDSTYLE_DIALOG		(WS_VISIBLE | WS_POPUPWINDOW | WS_CAPTION | WS_DLGFRAME | WS_CLIPSIBLINGS | WS_CLIPCHILDREN)

#define UI_CLASSSTYLE_FRAME		(CS_VREDRAW | CS_HREDRAW)
#define UI_CLASSSTYLE_DIALOG	(CS_VREDRAW | CS_HREDRAW | CS_DBLCLKS | CS_SAVEBITS)

#ifndef WM_DPICHANGED
#define WM_DPICHANGED       0x02E0
#endif

class UILIB_API WindowImplBase : public Window, public IUIMessageFilter
{
public:
	WindowImplBase();
	virtual ~WindowImplBase();

	/**
	 * @brief յڴϢʱ
	 * @return 
	 */
	virtual void InitWindow(){}

	/**
	 * @brief յϢʱ
	 * @param[in] hWnd ҪٵĴھ
	 * @return 
	 */
	virtual void OnFinalMessage( HWND hWnd ) override;

	/**
	 * @brief ȡʽ
	 * @return شʽ
	 */
	virtual LONG GetStyle();

	/**
	 * @brief ȡʽ
	 * @return شʽ
	 */
	virtual UINT GetClassStyle() const;

	/**
	 * @brief 
	 * @param[in] 
	 * @return 
	 */
	virtual std::wstring GetResourceID() const;

	/**
	 * @brief ҪĿؼǱ׼Ŀؼʱøú
	 * @param[in] pstrClass ؼ
	 * @return һԶؼָ룬һ¸ pstrClass ԶĿؼ
	 */
	virtual Control* CreateControl(const std::wstring& pstrClass);

	/**
	 * @brief Ϣ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief յڹرϢʱ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnClose(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief յڱϢʱ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief յǻ״̬Ϣʱ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnNcActivate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief յҪͻСϢʱWM_NCCALCSIZE
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnNcCalcSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief λû Z ıʱ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnWindowPosChanging(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief յƱϢʱ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnNcPaint(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief յ˫Ϣʱ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnNcLButtonDbClick(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief յ WM_NCHITTEST Ϣʱ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief յ WM_GETMINMAXINFO Ϣʱ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnGetMinMaxInfo(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief յϢʱ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnMouseWheel(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief յڴСıϢʱ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnMouseHover(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief յDPIıϢʱãֻ Startup ָ DPI Żᴥ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnDpiChanged(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief յڴСıϢʱ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief յַϢʱWM_CHAR
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnChar(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief մڿϢʱWM_SYSCOMMAND
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnSysCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief ռ̰Ϣʱ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief ʧȥϢʱ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief ջȡϢʱ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnSetFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief յϢʱ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief յϢʱ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnLButtonUp(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief յƶϢʱ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT OnMouseMove(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief Ϣɷ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled  true ɷϢɷϢ
	 * @return Ϣ
	 */
	virtual LRESULT HandleMessage(UINT uMsg, WPARAM wParam, LPARAM lParam) override;

public:
	/**
	* @brief 
	* @return void ޷ֵ
	*/
	virtual void ActiveWindow();

	/**
	* @brief ôڱ
	* @param[in] title ڱ
	* @return void ޷ֵ
	*/
	virtual void SetTaskbarTitle(const std::wstring &title);

	/**
	* @brief ö
	* @param[in] forever Ƿһֱö
	* @return void ޷ֵ
	*/
	void ToTopMost(bool forever);
		
protected:
	/**
	 * @brief ʱãʵԻȡƤĿ¼
	 * @return ʵֲشƤĿ¼
	 */
	virtual std::wstring GetSkinFolder() = 0;

	/**
	 * @brief ʱãʵԻȡƤ XML ļ
	 * @return ʵֲشƤ XML ļ
	 */
	virtual std::wstring GetSkinFile() = 0;

	/**
	 * @brief ʱãʵԻȡΨһ
	 * @return ʵֲشΨһ
	 */
	virtual std::wstring GetWindowClassName(void) const = 0 ;

private:
	/**
	 * @brief յڴϢʱãʹ InitWindow ӿʵԶ
	 * @param[in] uMsg ϢID
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled ϢǷѾ
	 * @return Ϣ
	 */
	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief ڹܰťʱ
	 * @param[in] param ЯĲ
	 * @return ʼշ true
	 */
	bool OnButtonClick(EventArgs* param);
};

}

#endif // UI_UTILS_WINIMPLBASE_H_
