#pragma once
#include "CivHydDataType.h"
#include "CivGraphList.h"
#include <vector>
#include <string>
#include <map>

#include "pandaAnalysis.h"

class  CivTrackingAnalysis
{
public:
	explicit CivTrackingAnalysis(const std::string& uri);
	~CivTrackingAnalysis();

	/**
	 *@brief ׷ٽڵ·
	 *@param sN ڵ㱾
	 *@param jsonResult ׷ٵĽjsonַ
	 */
	bool upstreamTracking(const std::string& sN, std::string&jsonResult);

	/**
	 *@brief ׷ٽڵ·
	 *@param sN ڵ㱾
	 *@param jsonResult ׷ٵĽַ
	 */
	bool downstreamTracking(const std::string& sN, std::string& jsonResult);

	/**
	 *@brief ĳˮԴܹˮķΧ
	 *@param sN ˮԴı
	 *@param jsonResult ַ
	 */
	bool waterSupplyScopeAnalysis(const std::string& sN, std::string& jsonResult);

	/**
	 *@brief ݿͼ
	 *@param uri ݿӵַ
	 */
	bool createGraphFrom();
private:
	

	/**
	*@brief ڵ͹ܶμϢתjsonַ
	*@param junctions ڵϢ
	*@param pipes ܶϢ
	*@param jsonResult Ľַ
	*/
	bool transformJson(const std::vector<CivGraphJunction>& junctions,
		const std::vector<CivGraphEdage>& pipes, std::string& jsonResult);

	/**
	*@brief ׷ٽڵ·
	*@param sN ڵ㱾
	*@param junctions ׷ٵĽڵ㼯
	*@param pipes ׷ٵĹܶμ
	*/
	bool upstreamTracking(const std::string& sN,
		std::vector<CivGraphJunction>& junctions,
		std::vector<CivGraphEdage>& pipes);

	/**
	*@brief ׷ٽڵ·
	*@param sN ڵ㱾
	*@param junctions ׷ٵĽڵ㼯
	*@param pipes ׷ٵĹܶμ
	*/
	bool downstreamTracking(const std::string& sN,
		std::vector<CivGraphJunction>& junctions, 
		std::vector<CivGraphEdage>& pipes);

	/**
	*@brief ĳˮԴܹˮķΧ
	*@param sN ˮԴı
	*@param junctions ԹˮĽڵ
	*@param pipes ԹˮĹܶ
	*/
	bool waterSupplyScopeAnalysis(const std::string& sN,
		std::vector<CivGraphJunction>& junctions,
		std::vector<CivGraphEdage>& pipes);

private:
	std::string mUri;
	std::map<std::string, std::string> mSnToCodeMap;
	ALGraph<CivGraphJunction, CivGraphEdage>* mGraph; // ͼ
};
