#include "CivInpDbHelper.h"
#include "CivTableFields.h"
#include "CivConnection.h"
#include "CivPgDbConnection.h"

#include <algorithm>

CivInpDbHelper::CivInpDbHelper(const std::string& uri)
	:CivInpHelperAbs(uri)
{
	mCondtion = "1=1 ";
	isDelayTime = true;
}

CivInpDbHelper::~CivInpDbHelper()
{
}

bool CivInpDbHelper::getNode(CivNode& node)
{
	JunctionTable nodeTableFields;
	std::vector<std::string> fields;

	fields.push_back(nodeTableFields.sn);
	fields.push_back(nodeTableFields.elev);
	fields.push_back(nodeTableFields.baseDemand);
	fields.push_back(nodeTableFields.demandPattern);

	std::vector<std::map<std::string,std::string>> resultVector;	
	mDbConn->query(PIPENODE, fields, resultVector, mCondtion);

	// ༭װ
	size_t total = resultVector.size();
	for (int i = 0; i < total; i++)
	{
		std::map<std::string, std::string> map = resultVector[i];
		CivNode::NodeTable nodeTable;

		nodeTable.ID = map.find(nodeTableFields.sn)->second;
		nodeTable.Elev = map.find(nodeTableFields.elev)->second;

		std::string patternID = map.find(nodeTableFields.demandPattern)->second;
		std::string demand = map.find(nodeTableFields.baseDemand)->second;

		handleDelayPattern(demand, patternID, nodeTable.Demand, nodeTable.PatternId);
		//// Ƿʱģ
		//if (isDelayTime)
		//{
		//	nodeTable.Demand = demand;
		//	nodeTable.PatternId = patternID;
		//}
		//else
		//{
		//	auto iter = mPatterns.find(patternID);
		//	if (iter != mPatterns.end())
		//	{
		//		std::vector<std::string> mulitiers = iter->second;
		//		if (mPatternTime > mulitiers.size())
		//			mPatternTime = mulitiers.size() - 1;

		//		if (mPatternTime < 0)
		//			mPatternTime = 0;

		//		std::string mulitier = mulitiers[mPatternTime];

		//		float intMul = std::atof(mulitier.c_str());
		//		float dem = std::atof(demand.c_str());

		//		demand = std::to_string(dem * intMul);
		//		nodeTable.Demand = demand;
		//	}
		//}
		node.addItem(nodeTable);
	}

	// ӴķŲĽڵ
	size_t size = mNodeVec.size();
	for (int i = 0; i < size; i++)
	{
		node.addItem(mNodeVec[i]);
	}
	return true;
}

bool CivInpDbHelper::getPipe(CivPipe& pipes)
{
	PipeTable pipeTable;

	std::vector<std::string> fields;
	fields.push_back(pipeTable.snNo); 
	fields.push_back(pipeTable.startPoint);
	fields.push_back(pipeTable.endPoint); 
	fields.push_back(pipeTable.length); 
	fields.push_back(pipeTable.diameter); 
	fields.push_back(pipeTable.friction); 
	fields.push_back(pipeTable.localLoss);
	fields.push_back(pipeTable.status);
	fields.push_back(pipeTable.code);
	
	std::vector<std::map<std::string, std::string>> resultVector;

	std::string condition = "\"from_layer\" not in ('','ˮ' ) and \"to_layer\" not in ('','ˮ' )";
	mDbConn->query(PIPELINE, fields, resultVector, condition);

	size_t total = resultVector.size();
    for (int i = 0; i < total; i++)
    {
        CivPipe::PipesTable pipe;

		std::map<std::string, std::string> map = resultVector[i];

		pipe.ID = map.find(pipeTable.snNo)->second;
		pipe.Node1 = map.find(pipeTable.startPoint)->second;
		pipe.Node2 = map.find(pipeTable.endPoint)->second;
		pipe.Length = map.find(pipeTable.length)->second;
		pipe.Diameter = map.find(pipeTable.diameter)->second;
		pipe.Roughness = map.find(pipeTable.friction)->second;
		pipe.MinorLoss = map.find(pipeTable.localLoss)->second;
		pipe.Status = map.find(pipeTable.status)->second;
		pipe.code = map.find(pipeTable.code)->second;
		pipes.addItem(pipe);
    }
	// Ĺܶ
	size_t size = mPipesVec.size();
	for (int i = 0; i < size; i++)
	{
		pipes.addItem(mPipesVec[i]);
	}
	return true;
}

bool CivInpDbHelper::getTank(CivTank& tanks)
{
	TankTable tankTable;

	std::vector<std::string> fields;

	fields.push_back(tankTable.sn);
	fields.push_back(tankTable.elev);
	fields.push_back(tankTable.initLevel);
	fields.push_back(tankTable.minLevel);
	fields.push_back(tankTable.maxLevel);
	fields.push_back(tankTable.diametor);
	fields.push_back(tankTable.minVolume);
	fields.push_back(tankTable.volumeCurve);

	std::vector<std::map<std::string, std::string>> resultVector;
	mDbConn->query(TANK, fields, resultVector, mCondtion);

	size_t total = resultVector.size();
	for (int i = 0; i < total; i++)
	{
		CivTank::TankTable tank;
		std::map<std::string, std::string>map = resultVector[i];

		tank.ID = map.find(tankTable.sn)->second;
		tank.Elev = map.find(tankTable.elev)->second;
		tank.InitLevel = map.find(tankTable.initLevel)->second;
		tank.MinLevel = map.find(tankTable.minLevel)->second;
		tank.MaxLevel = map.find(tankTable.maxLevel)->second;
		tank.Diameter = map.find(tankTable.diametor)->second;
		tank.MinVol = map.find(tankTable.minVolume)->second;
		tank.VolCurve = map.find(tankTable.volumeCurve)->second;
		
		tanks.addItem(tank);
	}
	return true;
}

bool CivInpDbHelper::getValve(CivValve& valves)
{
	/*ValveTable vaveTable;
	std::vector<std::string> fields;

	fields.push_back(vaveTable.sn); 
	fields.push_back(vaveTable.startPoint);
	fields.push_back(vaveTable.endPoint);
	fields.push_back(vaveTable.length);
	fields.push_back(vaveTable.type);
	fields.push_back(vaveTable.setting);
	fields.push_back(vaveTable.lossCoeff);

	std::vector<std::map<std::string, std::string>> resultVector;
	mDbConn->query(VALVE, fields, resultVector, mCondtion);

	size_t totals = resultVector.size();
	for (int i = 0; i < totals; i++)
	{
		CivValve::ValveTable vave;
		std::map<std::string, std::string> map = resultVector[i];

		std::string vaType = map.find(vaveTable.type)->second;
		if (vaType == "BV")
			continue;

		vave.ID = map.find(vaveTable.sn)->second;
		vave.Node1 = map.find(vaveTable.startPoint)->second;
		vave.Node2 = map.find(vaveTable.endPoint)->second;
		vave.Diameter = map.find(vaveTable.length)->second;
		vave.Type = map.find(vaveTable.type)->second;
		vave.Setting = map.find(vaveTable.setting)->second;
		vave.MinorLoss = map.find(vaveTable.lossCoeff)->second;

		valves.addItem(vave);
	}*/

	size_t size = mValuvesVec.size();
	for (int i = 0; i < size; i++)
	{
		valves.addItem(mValuvesVec[i]);
	}

	return true;
}

bool CivInpDbHelper::getPumps(CivPumps& pumps)
{
	PumpTable pmTable;
	std::vector<std::string> fields;

	fields.push_back(pmTable.sn);
	fields.push_back(pmTable.startPoint);
	fields.push_back(pmTable.endPoint);
	fields.push_back(pmTable.headCurve);
	fields.push_back(pmTable.power);

	std::vector<std::map<std::string, std::string>> resultVector;
	mDbConn->query(PUMP, fields, resultVector, mCondtion);
	
	size_t totals = resultVector.size();
	for (int i = 0; i < totals; i++)
	{
		CivPumps::PumpTable pump;
		std::map<std::string, std::string> map = resultVector[i];

		pump.ID = map.find(pmTable.sn)->second;
		pump.Node1 = map.find(pmTable.startPoint)->second;
		pump.Node2 = map.find(pmTable.endPoint)->second;
		std::string param;
		
		std::string curve = map.find(pmTable.headCurve)->second;
		if (curve != "")
			param.append("head " + curve);

		std::string power = map.find(pmTable.power)->second;
		if (power != "")
			param.append(" power " + power);
	
		pump.Parameters = param;
		pumps.addItem(pump);
	}
	return true;
}

bool CivInpDbHelper::getReservoirs(CivReservoirs& reservoirs)
{
	ResourcesTable restemTable;

	std::vector<std::string> fields;

	fields.push_back(restemTable.sn);
	fields.push_back(restemTable.totalHead);
	fields.push_back(restemTable.headPattern);

	std::vector<std::map<std::string, std::string>> resultVector;
	mDbConn->query(RESIVOIR, fields, resultVector, mCondtion);

	size_t totals = resultVector.size();
	for (int i = 0; i < totals; i++)
	{
		CivReservoirs::ReservoirsTable resTable;
		std::map<std::string, std::string> map = resultVector[i];

		resTable.ID = map.find(restemTable.sn)->second;
		resTable.Head = map.find(restemTable.totalHead)->second;
		resTable.Pattern = map.find(restemTable.headPattern)->second;

		reservoirs.addItem(resTable);
	}
	return true;
}

bool CivInpDbHelper::getCoordinates(CivCoordinates& coord)
{
	JunctionTable nodeTable;

	std::vector<std::string> fields;

	fields.push_back(nodeTable.sn);
	fields.push_back(nodeTable.xCoord);
	fields.push_back(nodeTable.yCoord);
	fields.push_back(nodeTable.code);

	std::vector<std::map<std::string, std::string>> resultVector;
	mDbConn->query(PIPENODE, fields, resultVector, mCondtion);
	mDbConn->query(TANK, fields, resultVector, mCondtion);
	mDbConn->query(RESIVOIR, fields, resultVector, mCondtion);

	size_t totals = resultVector.size();
	for (int i = 0; i < totals; i++)
	{
		CivCoordinates::CoordTable coordTable;
		std::map<std::string, std::string> map = resultVector[i];

		coordTable.ID = map.find(fields[0])->second;
		coordTable.XCoord = map.find(fields[1])->second;
		coordTable.YCoord = map.find(fields[2])->second;
		coordTable.code = map.find(nodeTable.code)->second;

		coord.addItem(coordTable);
	}
	// 뷧ŴĽڵ
	size_t size = mCoords.size();
	for (int i = 0; i < size; i++)
	{
		coord.addItem(mCoords[i]);
	}

	return true;
}

bool CivInpDbHelper::getQuality(CivQuality& quality)
{
	JunctionTable nodeTable;

	std::vector<std::string> fields;

	fields.push_back(nodeTable.sn);
	fields.push_back(nodeTable.initQuality);
	fields.push_back(nodeTable.chlorine);

	std::vector<std::map<std::string, std::string>> resultVector;
	mDbConn->query(PIPENODE, fields, resultVector, mCondtion);
	mDbConn->query(RESIVOIR, fields, resultVector,mCondtion);
	mDbConn->query(TANK, fields, resultVector, mCondtion);

	size_t totals = resultVector.size();
	for (int i = 0; i < totals; i++)
	{
		CivQuality::QualityTable quliTable;

		std::map<std::string, std::string> map = resultVector[i];
		quliTable.ID = map.find(nodeTable.sn)->second;
		switch (mQualityType)
		{
		
		case Chlorine:
			quliTable.InitQuality = map.find(nodeTable.chlorine)->second;
			break;
		case Age:
		default:
			quliTable.InitQuality = map.find(nodeTable.initQuality)->second;
			break;
		}

		quality.addItem(quliTable);
	}

	return true;
}

bool CivInpDbHelper::getStatus(CivStatus& status)
{
	//ValveTable vaTable;

	//std::vector<std::string> fields;
	//fields.push_back(vaTable.sn);
	//fields.push_back(vaTable.fixedState);
	//fields.push_back(vaTable.type);

	//std::vector<std::map<std::string, std::string>> resultVector;

	//mDbConn->query(VALVE, fields, resultVector);

	//size_t total = resultVector.size();
	//for (int i = 0; i < total; i++)
	//{
	//	CivStatus::StatusTable statTable;

	//	auto resMap = resultVector[i];
	//
	//	std::string state = resMap.find(vaTable.fixedState)->second;
	//	std::string type = resMap.find(vaTable.type)->second;

	//	std::transform(state.begin(), state.end(), state.begin(), ::toupper);
	//	if (type == "BV")
	//		continue;

	//	statTable.ID = resMap.find(vaTable.sn)->second;
	//	statTable.Setting = state;

	//	status.addItem(statTable);
	//}
	// ״ֵ̬
	size_t statuSize = mStatusVec.size();
	for (int i = 0; i < statuSize; i++)
	{
		status.addItem(mStatusVec[i]);
	}
	
	return true;
}

void CivInpDbHelper::handlePump()
{
	
}

void CivInpDbHelper::handleValve()
{
		  //ŵιܶ
		std::string dwPipeSql = "select pipe.\"\", ('UP' || pipe.\"ʼڵ\") as \"ʼڵ\", pipe.\"ֹڵ\", pipe.\"ܳ\", pipe.\"ܾ\",\
			pipe.\"Ħϵ\" ,pipe.\"ϵ\" from \"ܶ\" as pipe where pipe.\"from_layer\" = ''";

		if (!mDbConn->execSql(dwPipeSql))
			return;

		std::vector<std::map<std::string, std::string>> upPipes;
		mDbConn->queryResult(upPipes);
	
		size_t total = upPipes.size();
		for (int i = 0; i < total; i++)
		{
			std::map<std::string, std::string> pipe = upPipes[i];

			CivPipe::Table pipeStruct;
			pipeStruct.ID = pipe.find("")->second;
			pipeStruct.code = pipe.find("code")->second;
			pipeStruct.Node1 = pipe.find("ʼڵ")->second;
			pipeStruct.Node2 = pipe.find("ֹڵ")->second;
			pipeStruct.Length = pipe.find("ܳ")->second;
			pipeStruct.Diameter = pipe.find("ܾ")->second;
			pipeStruct.Roughness = pipe.find("Ħϵ")->second;
			pipeStruct.Status = "Open";
			pipeStruct.MinorLoss = pipe.find("ϵ")->second;

			mPipesVec.push_back(pipeStruct);
		}
	
		 // ŵιܶ
		std::string upPipeSql = "select pipe.\"\", pipe.\"ʼڵ\", ('DW' || pipe.\"ֹڵ\") as \"ֹڵ\", pipe.\"ܳ\", pipe.\"ܾ\", \
			pipe.\"Ħϵ\",pipe.\"ϵ\" from \"ܶ\" as pipe where pipe.\"to_layer\" = ''";

		if (!mDbConn->execSql(upPipeSql))
			return;

		std::vector<std::map<std::string, std::string>> downPipes;
		mDbConn->queryResult(downPipes);

		size_t dtotal = downPipes.size();
		for (int i = 0; i < dtotal; i++)
		{
			std::map<std::string, std::string> pipe = downPipes[i];

			CivPipe::Table pipeStruct;
			pipeStruct.ID = pipe.find("")->second;
			pipeStruct.code = pipe.find("code")->second;
			pipeStruct.Node1 = pipe.find("ʼڵ")->second;
			pipeStruct.Node2 = pipe.find("ֹڵ")->second;
			pipeStruct.Length = pipe.find("ܳ")->second;
			pipeStruct.Diameter = pipe.find("ܾ")->second;
			pipeStruct.Roughness = pipe.find("Ħϵ")->second;
			pipeStruct.Status = "Open";
			pipeStruct.MinorLoss = pipe.find("ϵ")->second;

			mPipesVec.push_back(pipeStruct);
		}

		//-- Ϣ--
		// 췧ʼڵ
		std::string vaStartSql = "SELECT \
		'UP' || va.\"\" AS \"\", vnode.\"߳\", vnode.\"ˮ\", vnode.\"ˮģʽ\" \
		, (va.\"\" - 1) AS \"\", (va.\"\" - 1) AS \"\", va.\"\" as \"ű\",\
		va.\"\" as \"\", ('UP' || va.\"\") as \"ʼڵ\", \
		va.\"ֱ\" as \"ֱ\",va.\"̶״̬\" as \"״̬\",va.\"\" as \"\",va.\"ˮϵ\"\
		FROM \"\" va, ( \
			SELECT node.\"\", node.\"߳\", node.\"ˮ\", node.\"ˮģʽ\", node.\"\"\
			, node.\"\", va.\"ֹڵ\"\
			FROM \"ڵ\" node, (\
				SELECT pipe.\"\", pipe.\"ʼڵ\", pipe.\"ֹڵ\", pipe.\"ܳ\", pipe.\"ܾ\"\
				, pipe.\"Ħϵ\"\
				FROM \"ܶ\" pipe\
				WHERE pipe.\"to_layer\" = ''\
				) va\
			WHERE node.\"\" = va.\"ʼڵ\"\
			) vnode \
		WHERE vnode.\"ֹڵ\" = va.\"\"";

		if (!mDbConn->execSql(vaStartSql))
			return;

		std::vector<std::map<std::string, std::string>> valvesVec;
		mDbConn->queryResult(valvesVec);

		std::map<std::string, CivValve::ValveTable> valveTableMap;
		std::map<std::string, CivPipe::PipesTable> pipeTableMap;
		size_t valvsSize = valvesVec.size();
		for (int i = 0; i < valvsSize; i++)
		{
			std::map<std::string, std::string> valveMap = valvesVec[i];

			// ڵ
			CivNode::NodeTable nodeTable;
			std::string szNo = valveMap.find("")->second;
			nodeTable.ID = szNo;	
			nodeTable.Elev = valveMap.find("߳")->second;
			
			std::string patternID = valveMap.find("ˮģʽ")->second;
			std::string demand = valveMap.find("ˮ")->second;
			handleDelayPattern(demand, patternID, nodeTable.Demand, nodeTable.PatternId);

			mNodeVec.push_back(nodeTable);

			// ڵ
			CivCoordinates::CoordTable coordTable;
			coordTable.ID = szNo;
			coordTable.XCoord = valveMap.find("")->second;
			coordTable.YCoord = valveMap.find("")->second;

			mCoords.push_back(coordTable);
	
			std::string valveSn = valveMap.find("ű")->second;
			std::string valveType = valveMap.find("")->second;
			
			if (valveType == "BV") // ֹطתɹܶ
			{
				CivPipe::Table pipeStruct;

				pipeStruct.ID = valveSn;
				pipeStruct.Node1 = szNo;
				pipeStruct.Length = "2";
				pipeStruct.Diameter = valveMap.find("ֱ")->second;
				pipeStruct.Roughness =std::string("130");//valveMap.find("Ħϵ")->second;
				pipeStruct.Status = (valveMap.find("״̬")->second == "Open")?"Open":"CV";
				pipeStruct.MinorLoss = "0";

				auto pter = std::make_pair(valveSn, pipeStruct);
				pipeTableMap.insert(pter);
			}
			else
			{
				// 
				CivValve::ValveTable valveTable;
				valveTable.ID = valveSn;
				valveTable.Node1 = szNo;
				valveTable.Diameter = valveMap.find("ֱ")->second;
				valveTable.Type = valveType;
				valveTable.Setting = valveMap.find("")->second;
				valveTable.MinorLoss = valveMap.find("ˮϵ")->second;

				valveTableMap.insert(std::make_pair(szNo, valveTable));

				// ״̬
				CivStatus::StatusTable statusTable;
				statusTable.ID = valveSn;
				statusTable.Setting = valveMap.find("̶״̬")->second;
				
				mStatusVec.push_back(statusTable);
			}
			
		}

	//--췧ֹڵ
	std::string vaEndSql =	"SELECT\
		'DW' || va.\"\" AS \"\", vnode.\"߳\", vnode.\"ˮ\", vnode.\"ˮģʽ\"\
		, (va.\"\" + 1) AS \"\", (va.\"\" + 1) AS \"\", va.\"\" as \"ű\",\
		va.\"\" as \"\", ('DW' || va.\"\") as \"ֹڵ\"\
		FROM \"\" va, (\
			SELECT node.\"\", node.\"߳\", node.\"ˮ\", node.\"ˮģʽ\", node.\"\"\
			, node.\"\", va.\"ʼڵ\"\
			FROM \"ڵ\" node, (\
				SELECT pipe.\"\", pipe.\"ʼڵ\", pipe.\"ֹڵ\", pipe.\"ܳ\", pipe.\"ܾ\"\
				, pipe.\"Ħϵ\"\
				FROM \"ܶ\" pipe\
				WHERE pipe.\"from_layer\" = ''\
				) va\
			WHERE node.\"\" = va.\"ֹڵ\"\
			) vnode\
		WHERE vnode.\"ʼڵ\" = va.\"\"";

	if (!mDbConn->execSql(vaEndSql))
		return;

	std::vector<std::map<std::string, std::string>> valvesEndVec;
	mDbConn->queryResult(valvesEndVec);

	size_t endVecSize = valvesEndVec.size();
	for (int i = 0; i < endVecSize; i++)
	{
		std::map<std::string, std::string> valveMap = valvesEndVec[i];

		// ڵ
		CivNode::NodeTable nodeTable;
		std::string szNo = valveMap.find("")->second;
		nodeTable.ID = szNo;
		nodeTable.Elev = valveMap.find("߳")->second;

		std::string patternID = valveMap.find("ˮģʽ")->second;
		std::string demand = valveMap.find("ˮ")->second;
		handleDelayPattern(demand, patternID, nodeTable.Demand, nodeTable.PatternId);

		mNodeVec.push_back(nodeTable);

		// ڵ
		CivCoordinates::CoordTable coordTable;
		coordTable.ID = szNo;
		coordTable.XCoord = valveMap.find("")->second;
		coordTable.YCoord = valveMap.find("")->second;

		mCoords.push_back(coordTable);

		std::string valveSn = valveMap.find("ű")->second;
		std::string valveType = valveMap.find("")->second;

		if (valveType == "BV") // ֹطתɹܶ
		{
			auto iter = pipeTableMap.find(valveSn);
			if (iter != pipeTableMap.end())
			{
				pipeTableMap[valveSn].Node2 = szNo;
				mPipesVec.push_back(iter->second);
			}
		}
		else
		{
			// 
			auto iter = valveTableMap.find(valveSn);
			if (iter != valveTableMap.end())
			{
				valveTableMap[valveSn].Node2 = szNo;
				mValuvesVec.push_back(iter->second);
			}
		}
	}
}