/** @file cef_control.h
 * @brief װCefΪduilibؼ
 * @copyright (c) 2016, NetEase Inc. All rights reserved
 * @author Redrain
 * @date 2016/7/19
 */
#pragma once
#include "cef_control_base.h"
#include "cef_control/util/memory_dc.h"

namespace nim_comp {

class CefControl :public CefControlBase, public IUIMessageFilter
{	
public:
	CefControl(void);
	~CefControl(void);	

	/// дӿڣṩԻ
	virtual void Init() override;
	virtual void SetPos(UiRect rc) override;
	virtual void HandleMessage(EventArgs& event) override;
	virtual void SetVisible(bool bVisible = true) override;
	virtual void SetInternVisible(bool bVisible = true) override;
	virtual void Paint(IRenderContext* pRender, const UiRect& rcPaint) override;
	virtual void SetWindow(ui::Window* pManager, ui::Box* pParent, bool bInit) override;

	virtual LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled) override; // ϢתCef

	/**
	* @brief 򿪿߹
	* @param[in] view һ CefControl ؼʵ(CefControlҪ)
	* @return ɹ trueʧܷ false
	*/
	virtual bool AttachDevTools(Control* view) override;

protected:
	virtual void ReCreateBrowser() override;

protected:
	/**
	 * @brief ת갴Ϣ BrowserHost
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled ǷϢ
	 * @return Ϣ
	 */
	LRESULT SendButtonDownEvent(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief ת˫Ϣ BrowserHost
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled ǷϢ
	 * @return Ϣ
	 */
	LRESULT SendButtonDoubleDownEvent(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief ת굯Ϣ BrowserHost
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled ǷϢ
	 * @return Ϣ
	 */
	LRESULT SendButtonUpEvent(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief תƶϢ BrowserHost
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled ǷϢ
	 * @return Ϣ
	 */
	LRESULT SendMouseMoveEvent(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief תϢ BrowserHost
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled ǷϢ
	 * @return Ϣ
	 */
	LRESULT SendMouseWheelEvent(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief ת뿪Ϣ BrowserHost
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled ǷϢ
	 * @return Ϣ
	 */
	LRESULT SendMouseLeaveEvent(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief תϢ BrowserHost
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled ǷϢ
	 * @return Ϣ
	 */
	LRESULT SendKeyEvent(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * @brief ת񽹵Ϣ BrowserHost
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam ϢӲ
	 * @param[in] lParam ϢӲ
	 * @param[out] bHandled ǷϢ
	 * @return Ϣ
	 */
	LRESULT SendCaptureLostEvent(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	
	/**
	 * @brief жǷа
	 * @param[in] wparam ϢӲ
	 * @return  true ʾа£false ʾûа
	 */
	static bool IsKeyDown(WPARAM wparam);

	/**
	 * @brief תͨϢ CEF ʶļϢ
	 * @param[in] wparam ϢӲ
	 * @param[in] lparam ϢӲ
	 * @return תĽ
	 */
	static int GetCefKeyboardModifiers(WPARAM wparam, LPARAM lparam);

	/**
	 * @brief תͨϢ CEF ʶϢ
	 * @param[in] wparam ϢӲ
	 * @return תĽ
	 */
	static int GetCefMouseModifiers(WPARAM wparam);

private:
	// Ⱦݱ仯ʱᴥ˽ӿڣʱȾݱ浽ڴdc
	// ֪ͨˢ¿ؼڿؼPaintڴdcλͼ
	// ɴʵȾݻ
	virtual void OnPaint(CefRefPtr<CefBrowser> browser,
		CefRenderHandler::PaintElementType type,
		const CefRenderHandler::RectList& dirtyRects,
		const std::string* buffer,
		int width,
		int height) OVERRIDE;

	virtual void OnPopupShow(CefRefPtr<CefBrowser> browser, bool show) OVERRIDE;

	virtual void OnPopupSize(CefRefPtr<CefBrowser> browser, const CefRect& rect) OVERRIDE;

private:
	MemoryDC			dc_cef_;		// ڴdc,cefȾݱ浽dc
	MemoryDC			dc_cef_popup_;	// ڴdc,cefpopupڵȾݱ浽dc
	CefRect				rect_popup_;	// ҳϿһĿؼʱ¼λ
};

}