#pragma once
#include "duilib/UIlib.h"

namespace nim_comp
{
/** @class WindowEx
 * @brief дĻ
 * @copyright (c) 2015, NetEase Inc. All rights reserved
 * @date 2015/9/16
 */
class WindowEx : public ui::WindowImplBase
{
public:
	WindowEx();
	virtual ~WindowEx();

	/**
	 * 
	 * @param[in] hwndParent ھ
	 * @param[in] pstrName 
	 * @param[in] dwStyle ʽ
	 * @param[in] dwExStyle չʽ
	 * @param[in] isLayeredWindow Ƿ񴴽ֲ㴰
	 * @param[in] rc λ
	 * @return HWND ھ
	 */
	virtual HWND Create(HWND hwndParent, LPCTSTR pstrName, DWORD dwStyle, DWORD dwExStyle,
		bool isLayeredWindow = true, const ui::UiRect& rc = ui::UiRect(0, 0, 0, 0)) override;

	/**
	 * ڱٵϢ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam 
	 * @param[in] lParam 
	 * @param[out] bHandled ϢǷ񱻴
	 * @return LRESULT 
	 */
	virtual LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	/**
	 * ESCϢ
	 * @param[out] bHandled ϢǷ񱻴
	 * @return void ޷ֵ
	 */
	virtual void OnEsc(BOOL &bHandled);

	/**
	 * ȡĽӿ
	 * @return wstring 
	 */
	virtual std::wstring GetWindowClassName(void) const = 0;

	/**
	 * ȡidĽӿ
	 * @return wstring id
	 */
	virtual std::wstring GetWindowId(void) const = 0;

	/**
	 * Ϣ
	 * @param[in] uMsg Ϣ
	 * @param[in] wParam 
	 * @param[in] lParam 
	 * @return LRESULT 
	 */
	virtual LRESULT HandleMessage(UINT uMsg, WPARAM wParam, LPARAM lParam);

private:
	/**
	 * WindowManagerעԼ
	 * @return bool true עɹfalse עʧ
	 */
	bool RegisterWnd();

	/**
	 * WindowManagerзעԼ
	 * @return void ޷ֵ
	 */
	void UnRegisterWnd();
};

/**
* ȡڿʾ½λõ
* @return POINT 
*/
POINT GetPopupWindowPos(WindowEx* window);

}